/*
 Navicat Premium Data Transfer

 Source Server         : 楼上mysql
 Source Server Type    : MySQL
 Source Server Version : 50738
 Source Host           : 192.168.2.39:13306
 Source Schema         : junmppolicesql

 Target Server Type    : MySQL
 Target Server Version : 50738
 File Encoding         : 65001

 Date: 08/11/2022 09:03:43
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for alipay_config
-- ----------------------------
DROP TABLE IF EXISTS `alipay_config`;
CREATE TABLE `alipay_config`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `app_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `charset` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `format` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `gateway_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `notify_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `private_key` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `public_key` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `return_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sign_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sys_service_provider_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for api_mqtt_message
-- ----------------------------
DROP TABLE IF EXISTS `api_mqtt_message`;
CREATE TABLE `api_mqtt_message`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `createTime` datetime NULL DEFAULT NULL,
  `deviceType` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备类型',
  `deviceNo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备编号',
  `topic` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '标题',
  `payload` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '内容',
  `token` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '时间戳token',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `token`(`token`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_charge
-- ----------------------------
DROP TABLE IF EXISTS `base_charge`;
CREATE TABLE `base_charge`  (
  `id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equ_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equ_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `epc` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `startTime` datetime NOT NULL,
  `endTime` datetime NOT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_app
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_app`;
CREATE TABLE `base_jp_app`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `app_key` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `secret_key` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `app_type` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `state` bit(1) NULL DEFAULT NULL,
  `access_token` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `refresh_token` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `expiration_time` datetime NULL DEFAULT NULL,
  `org_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  UNIQUE INDEX `app_key`(`app_key`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_bag
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_bag`;
CREATE TABLE `base_jp_bag`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `orgId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `name` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `num` int(11) NULL DEFAULT 0,
  `is_delete` bit(1) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `orgId`(`orgId`) USING BTREE,
  CONSTRAINT `FK_base_jp_bag_base_jp_organization` FOREIGN KEY (`orgId`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_bag_map
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_bag_map`;
CREATE TABLE `base_jp_bag_map`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `bag_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `detail_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `count` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `bag_id`(`bag_id`) USING BTREE,
  INDEX `detail_id`(`detail_id`) USING BTREE,
  CONSTRAINT `FK__base_jp_b__bag_i__0B129727` FOREIGN KEY (`bag_id`) REFERENCES `base_jp_bag` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__base_jp_b__detai__0C06BB60` FOREIGN KEY (`detail_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_cabinet
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_cabinet`;
CREATE TABLE `base_jp_cabinet`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `cabinet_real_num` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinet_num` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinet_child_num` int(11) NOT NULL,
  `organization_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `location` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `short_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `state` int(11) NULL DEFAULT NULL,
  `use_time` datetime NULL DEFAULT NULL,
  `buy_time` datetime NULL DEFAULT NULL,
  `type` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `organization_id`(`organization_id`) USING BTREE,
  CONSTRAINT `base_jp_cabinet_ibfk_1` FOREIGN KEY (`organization_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_cabinet_inv_error_msg
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_cabinet_inv_error_msg`;
CREATE TABLE `base_jp_cabinet_inv_error_msg`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinet_real_num` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinet_num` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinet_child_num` int(11) NOT NULL,
  `organization_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `state` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `msg` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `push_time` datetime NULL DEFAULT NULL,
  `user_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_user_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cabinet_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `epc` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for base_jp_cabinet_outinlog
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_cabinet_outinlog`;
CREATE TABLE `base_jp_cabinet_outinlog`  (
  `id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `state` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `userName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `boxNum` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `count` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `time` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `photo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `epc` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `deviceNo` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pushTime` datetime NULL DEFAULT NULL,
  `operationTime` datetime NULL DEFAULT NULL,
  `organization_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `organization_id`(`organization_id`) USING BTREE,
  CONSTRAINT `FK__base_jp_c__organ__15C52FC4` FOREIGN KEY (`organization_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_cabinet_policeman
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_cabinet_policeman`;
CREATE TABLE `base_jp_cabinet_policeman`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `policeman_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cabinet_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `cabinet_id`(`cabinet_id`) USING BTREE,
  INDEX `policeman_id`(`policeman_id`) USING BTREE,
  CONSTRAINT `base_jp_cabinet_policeman_ibfk_1` FOREIGN KEY (`cabinet_id`) REFERENCES `base_jp_cabinet` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `base_jp_cabinet_policeman_ibfk_2` FOREIGN KEY (`policeman_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_cabinet_policeman_multiple
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_cabinet_policeman_multiple`;
CREATE TABLE `base_jp_cabinet_policeman_multiple`  (
  `id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinetRealID` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `boxNo` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `userName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `userId` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_cabinet_worklog
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_cabinet_worklog`;
CREATE TABLE `base_jp_cabinet_worklog`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `type` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(60) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `logInfo` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `date` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `photo` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isDeal` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `deviceNo` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_equipment_detail
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_equipment_detail`;
CREATE TABLE `base_jp_equipment_detail`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `unit` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `note` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `state` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `update_time` datetime NOT NULL,
  `update_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `alias_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '别名',
  `unit_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物资单位',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `_dta_index_base_jp_equipment_detail_8_773577794__K1_3_4`(`id`) USING BTREE,
  INDEX `_dta_index_base_jp_equipment_detail_8_773577794__K1_4`(`id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `UQ__base_jp___357D4CF97AE516C8`(`code`) USING BTREE,
  CONSTRAINT `base_jp_equipment_detail_ibfk_1` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_info` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_equipment_info
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_equipment_info`;
CREATE TABLE `base_jp_equipment_info`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `parent_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `parent_id`(`parent_id`) USING BTREE,
  CONSTRAINT `KD_PAREINT_ID` FOREIGN KEY (`parent_id`) REFERENCES `base_jp_equipment_info` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_equipment_size
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_equipment_size`;
CREATE TABLE `base_jp_equipment_size`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `size_code` int(11) NULL DEFAULT NULL,
  `size_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `detail_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `note` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `update_time` datetime NOT NULL,
  `epc_type` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `detail_id`(`detail_id`) USING BTREE,
  CONSTRAINT `base_jp_equipment_size_ibfk_1` FOREIGN KEY (`detail_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_key_value
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_key_value`;
CREATE TABLE `base_jp_key_value`  (
  `key` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `value` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`key`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for base_jp_log
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_log`;
CREATE TABLE `base_jp_log`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `create_time` datetime NULL DEFAULT NULL,
  `description` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `exception_detail` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `log_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `method` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `params` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `request_ip` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `time` int(11) NULL DEFAULT NULL,
  `username` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `address` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `browser` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 673 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_model
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_model`;
CREATE TABLE `base_jp_model`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `isdefault` bit(1) NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  CONSTRAINT `FK_base_jp_model_base_jp_organization` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_organization
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_organization`;
CREATE TABLE `base_jp_organization`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `find_code` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `area_name` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `state` smallint(6) NULL DEFAULT NULL,
  `parent_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name_jc` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `d_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `show` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_map` smallint(6) NULL DEFAULT 0,
  `order_count` int(11) NULL DEFAULT NULL COMMENT '打印单据数量',
  `longitude` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '经度',
  `latitude` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '纬度',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `_dta_index_base_jp_organization_8_837578022__K3D_K8`(`code`, `state`) USING BTREE,
  INDEX `_dta_index_base_jp_organization_8_837578022__K3D_K8_1_2_4_5_6_7`(`code`, `state`) USING BTREE,
  INDEX `_dta_index_base_jp_organization_8_837578022__K8`(`state`) USING BTREE,
  INDEX `_dta_index_base_jp_organization_8_837578022__K8_K3_1_2_4_5_6_7_`(`state`, `code`) USING BTREE,
  INDEX `_dta_index_base_jp_organization_8_837578022__K8_K3_1_2_4_500000`(`state`, `code`) USING BTREE,
  INDEX `_dta_index_base_jp_organization_8_837578022__K8_K3D`(`state`, `code`) USING BTREE,
  INDEX `_dta_index_base_jp_organization_8_837578022__K8_K3D_1_2_4_5_6_7`(`state`, `code`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_policefinger
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_policefinger`;
CREATE TABLE `base_jp_policefinger`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `police_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `finger_info` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `type` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `finger_num` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `police_id`(`police_id`) USING BTREE,
  CONSTRAINT `FK_base_jp_policefinger_base_jp_policefinger` FOREIGN KEY (`police_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_policeman
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_policeman`;
CREATE TABLE `base_jp_policeman`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinet_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `orgization_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `police_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `sex` varchar(3) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `finger_info2` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `finger_info1` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `face_info` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `password` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `photo` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `phone` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NOT NULL,
  `update_time` datetime NOT NULL,
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `IsCreatedAccount` bit(1) NOT NULL DEFAULT b'0',
  `cardNo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `cabinet_id`(`cabinet_id`) USING BTREE,
  INDEX `orgization_code`(`orgization_code`) USING BTREE,
  CONSTRAINT `base_jp_policeman_ibfk_1` FOREIGN KEY (`orgization_code`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `base_jp_policeman_ibfk_2` FOREIGN KEY (`cabinet_id`) REFERENCES `base_jp_cabinet` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_process
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_process`;
CREATE TABLE `base_jp_process`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `description` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `publish_status` bit(1) NOT NULL,
  `process_xml` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_shelf_info
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_shelf_info`;
CREATE TABLE `base_jp_shelf_info`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouseId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `shelf_size` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `row` int(11) NULL DEFAULT NULL,
  `column` int(11) NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `range` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `warehouseId`(`warehouseId`) USING BTREE,
  CONSTRAINT `FK__base_jp_s__wareh__05F8DC4F` FOREIGN KEY (`warehouseId`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_soft_update
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_soft_update`;
CREATE TABLE `base_jp_soft_update`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `address` varchar(250) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `note` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` varchar(125) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `version` int(11) NULL DEFAULT NULL,
  `updateTime` datetime NULL DEFAULT NULL,
  `appCode` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `version2` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fileMD5` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isAutoUpdate` bit(1) NULL DEFAULT b'0',
  `autoUpdateAddress` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `autoUpdateFileMD5` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `autoUpdateVersion2` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_supplier
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_supplier`;
CREATE TABLE `base_jp_supplier`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `supplier_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `short_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `contacts` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `phone` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_supplier_equipment
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_supplier_equipment`;
CREATE TABLE `base_jp_supplier_equipment`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `supplier_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `state` int(11) NOT NULL,
  `useless_uint` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `useless_time` int(11) NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `update_time` datetime NOT NULL,
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `num` int(11) NULL DEFAULT 0,
  PRIMARY KEY (`equipment_id`, `supplier_code`) USING BTREE,
  INDEX `supplier_code`(`supplier_code`) USING BTREE,
  CONSTRAINT `FK_base_jp_supplier_equipment_base_jp_equipment_detail` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_base_jp_supplier_equipment_base_jp_supplier` FOREIGN KEY (`supplier_code`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_warehouse
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_warehouse`;
CREATE TABLE `base_jp_warehouse`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `location` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `location_detail` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `orgization_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `phone` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `update_time` datetime NOT NULL,
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_locked` bit(1) NULL DEFAULT b'0',
  `camera_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `channel_read_equ_type_json` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '通道读取装备类型json',
  `is_enable_channel_read_equ` bit(1) NULL DEFAULT NULL COMMENT '是否启用通道读取指定类型装备',
  `is_disabled` bit(1) NULL DEFAULT b'0' COMMENT '是否停用仓库',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `orgization_id`(`orgization_id`) USING BTREE,
  CONSTRAINT `base_jp_warehouse_ibfk_1` FOREIGN KEY (`orgization_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_warehouse_dev
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_warehouse_dev`;
CREATE TABLE `base_jp_warehouse_dev`  (
  `dev_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dev_ip` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dev_port` int(11) NULL DEFAULT NULL,
  `dev_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dev_code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_sd` double NULL DEFAULT NULL,
  `warehouse_wd` double NULL DEFAULT NULL,
  `dev_state` int(11) NULL DEFAULT NULL,
  `set_sd` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`dev_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  CONSTRAINT `ky_warehouse` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for base_jp_warehouse_dev_history
-- ----------------------------
DROP TABLE IF EXISTS `base_jp_warehouse_dev_history`;
CREATE TABLE `base_jp_warehouse_dev_history`  (
  `dev_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dev_ip` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dev_port` int(11) NULL DEFAULT NULL,
  `dev_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dev_code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_sd` double NULL DEFAULT NULL,
  `warehouse_wd` double NULL DEFAULT NULL,
  `dev_state` int(11) NULL DEFAULT NULL,
  `update_time` datetime NOT NULL,
  PRIMARY KEY (`dev_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  CONSTRAINT `ky_warehouse1` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for c_area_list
-- ----------------------------
DROP TABLE IF EXISTS `c_area_list`;
CREATE TABLE `c_area_list`  (
  `findCode` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `areaName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sumCount` int(11) NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for c_sy_p
-- ----------------------------
DROP TABLE IF EXISTS `c_sy_p`;
CREATE TABLE `c_sy_p`  (
  `parentName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `weekP` double NULL DEFAULT NULL,
  `monthP` double NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for column_config
-- ----------------------------
DROP TABLE IF EXISTS `column_config`;
CREATE TABLE `column_config`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `column_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `column_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `date_annotation` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dict_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `extra` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `form_show` bit(1) NULL DEFAULT NULL,
  `form_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `key_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `list_show` bit(1) NULL DEFAULT NULL,
  `not_null` bit(1) NULL DEFAULT NULL,
  `query_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `table_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_bag_inventory
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_bag_inventory`;
CREATE TABLE `common_jp_bag_inventory`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `epc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `bag_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `print_state` int(11) NULL DEFAULT NULL,
  `number` int(11) NULL DEFAULT NULL,
  `need_number` int(11) NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_delete` bit(1) NULL DEFAULT NULL,
  `state` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `bag_id`(`bag_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__bag_i__0CFADF99` FOREIGN KEY (`bag_id`) REFERENCES `base_jp_bag` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__wareh__10CB707D` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_borrow_return
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_borrow_return`;
CREATE TABLE `common_jp_borrow_return`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `policeman_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_state` int(11) NOT NULL,
  `action_type` int(11) NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `out_time` datetime NULL DEFAULT NULL,
  `order_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isAfter` bit(1) NULL DEFAULT NULL,
  `is_work` bit(1) NOT NULL DEFAULT b'0',
  `update_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `policeman_id`(`policeman_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `apply_id`(`apply_id`) USING BTREE,
  CONSTRAINT `common_jp_borrow_return_ibfk_1` FOREIGN KEY (`policeman_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_ibfk_4` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_ibfk_5` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_ibfk_6` FOREIGN KEY (`apply_id`) REFERENCES `common_jp_borrow_return_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_borrow_return_apply
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_borrow_return_apply`;
CREATE TABLE `common_jp_borrow_return_apply`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `action_type` int(11) NOT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `return_time` datetime NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_time` datetime NULL DEFAULT NULL,
  `approval_result` int(11) NULL DEFAULT NULL,
  `approval_person` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_time` datetime NULL DEFAULT NULL,
  `approval_msg` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `order_code` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `note` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `approval_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_user_name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_user_name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isAfter` bit(1) NULL DEFAULT NULL,
  `expectedReturnTime` date NULL DEFAULT NULL,
  `process_current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `change_flag` int(11) NULL DEFAULT NULL,
  `police_note` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `apply_id`(`apply_id`) USING BTREE,
  INDEX `approval_person`(`approval_person`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `process_current_id`(`process_current_id`) USING BTREE,
  CONSTRAINT `common_jp_borrow_return_apply_ibfk_2` FOREIGN KEY (`apply_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_apply_ibfk_3` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_apply_ibfk_4` FOREIGN KEY (`approval_person`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_apply_ibfk_5` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_apply_ibfk_6` FOREIGN KEY (`process_current_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_borrow_return_detail_estimate
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_borrow_return_detail_estimate`;
CREATE TABLE `common_jp_borrow_return_detail_estimate`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `estimate_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_count` int(11) NOT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `estimate_id`(`estimate_id`) USING BTREE,
  CONSTRAINT `common_jp_borrow_return_detail_estimate_ibfk_2` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_detail_estimate_ibfk_4` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_detail_estimate_ibfk_5` FOREIGN KEY (`estimate_id`) REFERENCES `common_jp_borrow_return_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_detail_estimate_ibfk_6` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_borrow_return_detail_reality
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_borrow_return_detail_reality`;
CREATE TABLE `common_jp_borrow_return_detail_reality`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `reality_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `estimate_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `state` int(11) NULL DEFAULT 0,
  `equipment_count` int(11) NULL DEFAULT NULL,
  `equipment_detail_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `real_count` int(11) NULL DEFAULT 0,
  `inside_real_count` int(11) NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_detail_id`(`equipment_detail_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `reality_id`(`reality_id`) USING BTREE,
  INDEX `estimate_id`(`estimate_id`) USING BTREE,
  CONSTRAINT `common_jp_borrow_return_detail_reality_ibfk_4` FOREIGN KEY (`equipment_detail_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_detail_reality_ibfk_5` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_detail_reality_ibfk_6` FOREIGN KEY (`reality_id`) REFERENCES `common_jp_borrow_return` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_detail_reality_ibfk_7` FOREIGN KEY (`estimate_id`) REFERENCES `common_jp_borrow_return_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_borrow_return_detail_reality_ibfk_8` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_channel_cfg
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_channel_cfg`;
CREATE TABLE `common_jp_channel_cfg`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouseId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `location` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `currentState` bit(1) NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `createTime` datetime NULL DEFAULT NULL,
  `updateUser` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `faceUser` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `facePwd` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `facePort` int(11) NULL DEFAULT NULL,
  `faceAddress` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `readerTime` int(11) NULL DEFAULT NULL,
  `faceEnable` bit(1) NULL DEFAULT NULL,
  `filterTime` int(11) NULL DEFAULT NULL,
  `readerAddress` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `camAddress` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `camPort` int(11) NULL DEFAULT NULL,
  `camUser` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `camPwd` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `useSnapshot` bit(1) NULL DEFAULT NULL,
  `camType` int(11) NULL DEFAULT NULL,
  `camChannel` int(11) NULL DEFAULT NULL,
  `gpioAddr` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `gpioPort` int(11) NULL DEFAULT NULL,
  `useGpio` bit(1) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `warehouseId`(`warehouseId`) USING BTREE,
  CONSTRAINT `common_jp_channel_cfg_ibfk_1` FOREIGN KEY (`warehouseId`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_channel_cfg_v2
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_channel_cfg_v2`;
CREATE TABLE `common_jp_channel_cfg_v2`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouseId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `location` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `currentState` bit(1) NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `createTime` datetime NULL DEFAULT NULL,
  `updateUser` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `readerConfigJson` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `filterTime` int(11) NULL DEFAULT NULL,
  `faceConfigJson` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `warehouseId`(`warehouseId`) USING BTREE,
  CONSTRAINT `FK__common_jp__wareh__7B4643B2` FOREIGN KEY (`warehouseId`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_channel_monitor_record
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_channel_monitor_record`;
CREATE TABLE `common_jp_channel_monitor_record`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `createTime` datetime NULL DEFAULT NULL,
  `out_in_state` int(11) NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `police_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pic_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `police_id`(`police_id`) USING BTREE,
  CONSTRAINT `common_jp_channel_monitor_record_ibfk_1` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_channel_monitor_record_ibfk_2` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_channel_monitor_record_ibfk_3` FOREIGN KEY (`police_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for common_jp_channel_monitor_record_inventory
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_channel_monitor_record_inventory`;
CREATE TABLE `common_jp_channel_monitor_record_inventory`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `createTime` datetime NULL DEFAULT NULL,
  `record_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `epc` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `inventory_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `epc_type` int(11) NULL DEFAULT NULL COMMENT 'epc类型\r\n0：件标\r\n1：箱标\r\n2：装备包',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `record_id`(`record_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `inventory_id`(`inventory_id`) USING BTREE,
  CONSTRAINT `common_jp_channel_monitor_record_inventory_ibfk_1` FOREIGN KEY (`record_id`) REFERENCES `common_jp_channel_monitor_record` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_channel_monitor_record_inventory_ibfk_2` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_channel_monitor_record_inventory_ibfk_3` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_channel_monitor_record_inventory_ibfk_4` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_channel_monitor_record_inventory_ibfk_5` FOREIGN KEY (`inventory_id`) REFERENCES `common_jp_equipment_inventory` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for common_jp_epc_gscode
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_epc_gscode`;
CREATE TABLE `common_jp_epc_gscode`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `epc` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `gsCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_equipment_box_mark
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_equipment_box_mark`;
CREATE TABLE `common_jp_equipment_box_mark`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `epc` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `oneBoxNum` int(11) NULL DEFAULT NULL,
  `equipmentDetailId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sizeId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplierId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `currentState` int(11) NULL DEFAULT NULL,
  `warehouseId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reloadBoxingState` int(11) NULL DEFAULT NULL,
  `oldEpc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipmentDetailId`(`equipmentDetailId`) USING BTREE,
  INDEX `sizeId`(`sizeId`) USING BTREE,
  INDEX `supplierId`(`supplierId`) USING BTREE,
  INDEX `warehouseId`(`warehouseId`) USING BTREE,
  CONSTRAINT `FK__common_jp__equip__7740A8A4` FOREIGN KEY (`equipmentDetailId`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__sizeI__7834CCDD` FOREIGN KEY (`sizeId`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__suppl__7928F116` FOREIGN KEY (`supplierId`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__wareh__7A1D154F` FOREIGN KEY (`warehouseId`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_equipment_history
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_equipment_history`;
CREATE TABLE `common_jp_equipment_history`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `Sort` int(11) NULL DEFAULT NULL,
  `equipment_state` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `operator` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `warehouse` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `operate_time` datetime NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_code`(`equipment_code`) USING BTREE,
  INDEX `operator`(`operator`) USING BTREE,
  INDEX `warehouse`(`warehouse`) USING BTREE,
  CONSTRAINT `common_jp_equipment_history_ibfk_1` FOREIGN KEY (`operator`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_history_ibfk_2` FOREIGN KEY (`equipment_code`) REFERENCES `base_jp_equipment_info` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_history_ibfk_3` FOREIGN KEY (`warehouse`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_equipment_inventory
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_equipment_inventory`;
CREATE TABLE `common_jp_equipment_inventory`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `supplier_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `epc` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `police_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `wzdm` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cabinet_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_sizecode` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equipment_location` int(11) NOT NULL,
  `current_state` int(11) NOT NULL,
  `out_time` datetime NULL DEFAULT NULL,
  `return_time` datetime NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `first_use_time` datetime NULL DEFAULT NULL,
  `fix_count` int(11) NULL DEFAULT NULL,
  `create_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `update_user` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `warrantyCycle` int(11) NULL DEFAULT NULL,
  `repairCycle` int(11) NULL DEFAULT NULL,
  `productTime` datetime NULL DEFAULT NULL,
  `useTime` datetime NULL DEFAULT NULL,
  `price` decimal(12, 2) NULL DEFAULT NULL,
  `useDirection` int(11) NULL DEFAULT NULL,
  `is_borrowed` bit(1) NULL DEFAULT b'0',
  `address` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lostFlag` bit(1) NULL DEFAULT b'0',
  `shelfId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `inventory_state` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'normal',
  `isInBox` bit(1) NULL DEFAULT b'0',
  `shelf_row` int(11) NULL DEFAULT NULL,
  `shelf_column` int(11) NULL DEFAULT NULL,
  `shelf_range` int(11) NULL DEFAULT NULL,
  `safe_level` int(11) NULL DEFAULT 0,
  `box_mark_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `instantiation_state` int(11) NULL DEFAULT NULL,
  `third_code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `bag_inventory_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_need_push_update` bit(1) NULL DEFAULT b'0',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `NonClusteredIndex-20200901-104052`(`id`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_inventory_8_1109578991__K1_K4_K12`(`id`, `epc`, `current_state`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_inventory_8_1109578991__K12_K1_K`(`current_state`, `id`, `warehouse_code`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_inventory_8_1109578991__K20_K23_`(`warrantyCycle`, `useTime`, `warehouse_code`, `equipment_sizecode`, `equipment_code`, `supplier_code`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_inventory_8_1109578991__K20_K8_K`(`warrantyCycle`, `warehouse_code`, `useTime`, `equipment_sizecode`, `equipment_code`, `supplier_code`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_inventory_8_1109578991__K6_K8_K9`(`equipment_code`, `warehouse_code`, `cabinet_id`, `equipment_sizecode`, `current_state`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_inventory_8_1109578991__K8_K1_K10`(`warehouse_code`, `id`, `equipment_sizecode`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_inventory_8_1109578991__K8_K10`(`warehouse_code`, `equipment_sizecode`) USING BTREE,
  INDEX `ClusteredIndex-20200901-100012`(`warehouse_code`) USING BTREE,
  INDEX `cabinet_id`(`cabinet_id`) USING BTREE,
  INDEX `equipment_sizecode`(`equipment_sizecode`) USING BTREE,
  INDEX `police_code`(`police_code`) USING BTREE,
  INDEX `shelfId`(`shelfId`) USING BTREE,
  INDEX `supplier_code`(`supplier_code`) USING BTREE,
  INDEX `bag_inventory_id`(`bag_inventory_id`) USING BTREE,
  INDEX `box_mark_id`(`box_mark_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__bag_i__0FD74C44` FOREIGN KEY (`bag_inventory_id`) REFERENCES `common_jp_bag_inventory` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__box_m__7187CF4E` FOREIGN KEY (`box_mark_id`) REFERENCES `common_jp_equipment_box_mark` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__polic__6A1BB7B0` FOREIGN KEY (`police_code`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__shelf__06ED0088` FOREIGN KEY (`shelfId`) REFERENCES `base_jp_shelf_info` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_inventory_ibfk_1` FOREIGN KEY (`supplier_code`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_inventory_ibfk_3` FOREIGN KEY (`equipment_code`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_inventory_ibfk_4` FOREIGN KEY (`warehouse_code`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_inventory_ibfk_5` FOREIGN KEY (`equipment_sizecode`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_inventory_ibfk_6` FOREIGN KEY (`cabinet_id`) REFERENCES `base_jp_cabinet` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_equipment_state
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_equipment_state`;
CREATE TABLE `common_jp_equipment_state`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `eqiupment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `out_in_state` int(11) NULL DEFAULT NULL,
  `state` int(11) NOT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `borrow_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cabinet_id_into` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cabinet_id_out` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `error_Epc` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `purchase_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `transfer_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fix_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `outTime` datetime NULL DEFAULT NULL,
  `police_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `intoTime` datetime NULL DEFAULT NULL,
  `createTime` datetime NULL DEFAULT NULL,
  `action_state` int(11) NULL DEFAULT NULL,
  `pic_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `parent_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `note` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `history_safe_level` int(11) NULL DEFAULT 0,
  `return_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `bag_inventory_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `mission_model_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_push` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `NonClusteredIndex-20200901-104118`(`id`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_state_8_1125579048__K19_K5_K15_K3`(`action_state`, `state`, `outTime`, `eqiupment_id`, `error_Epc`, `parent_id`, `org_id`) USING BTREE,
  INDEX `_dta_index_common_jp_equipment_state_8_1125579048__K3_K1_2_4_5_`(`eqiupment_id`, `id`) USING BTREE,
  INDEX `ClusteredIndex-20201113-135343`(`createTime`) USING BTREE,
  INDEX `NonClusteredIndex-20201113-125142`(`out_in_state`, `action_state`) USING BTREE,
  INDEX `cabinet_id_out`(`cabinet_id_out`) USING BTREE,
  INDEX `cabinet_id_into`(`cabinet_id_into`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `police_id`(`police_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `bag_inventory_id`(`bag_inventory_id`) USING BTREE,
  INDEX `borrow_id`(`borrow_id`) USING BTREE,
  INDEX `fix_id`(`fix_id`) USING BTREE,
  INDEX `return_id`(`return_id`) USING BTREE,
  INDEX `mission_model_id`(`mission_model_id`) USING BTREE,
  INDEX `purchase_id`(`purchase_id`) USING BTREE,
  INDEX `transfer_id`(`transfer_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__retur__69E6AD86` FOREIGN KEY (`return_id`) REFERENCES `common_jp_inventory_return_apply_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_equipment_state_common_jp_bag_inventory` FOREIGN KEY (`bag_inventory_id`) REFERENCES `common_jp_bag_inventory` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_equipment_state_common_jp_equipment_inventory` FOREIGN KEY (`eqiupment_id`) REFERENCES `common_jp_equipment_inventory` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_equipment_state_common_jp_fix_useless_detail` FOREIGN KEY (`fix_id`) REFERENCES `common_jp_fix_useless_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_equipment_state_common_jp_misssion_child` FOREIGN KEY (`mission_model_id`) REFERENCES `common_jp_mission` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_equipment_state_common_jp_purchase_detail` FOREIGN KEY (`purchase_id`) REFERENCES `common_jp_purchase_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_state_ibfk_3` FOREIGN KEY (`borrow_id`) REFERENCES `common_jp_borrow_return_detail_reality` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_state_ibfk_4` FOREIGN KEY (`cabinet_id_out`) REFERENCES `base_jp_cabinet` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_state_ibfk_5` FOREIGN KEY (`transfer_id`) REFERENCES `common_jp_transfer_detail_reality` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_state_ibfk_6` FOREIGN KEY (`cabinet_id_into`) REFERENCES `base_jp_cabinet` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_state_ibfk_7` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_state_ibfk_8` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_equipment_state_ibfk_9` FOREIGN KEY (`police_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_equipment_threshold
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_equipment_threshold`;
CREATE TABLE `common_jp_equipment_threshold`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NOT NULL,
  `equipment_detail_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equipment_size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `threshold_count` int(11) NOT NULL,
  `is_enabled` bit(1) NOT NULL DEFAULT b'0',
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `scope_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_detail_id`(`equipment_detail_id`) USING BTREE,
  INDEX `equipment_size_id`(`equipment_size_id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__equip__4D4A6ED8` FOREIGN KEY (`equipment_detail_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__equip__4E3E9311` FOREIGN KEY (`equipment_size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__org_i__4F32B74A` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__wareh__5303482E` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_equipment_threshold_result
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_equipment_threshold_result`;
CREATE TABLE `common_jp_equipment_threshold_result`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NOT NULL,
  `threshold_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `inside_count` int(11) NOT NULL DEFAULT 0,
  `real_inside_count` int(11) NOT NULL DEFAULT 0,
  `purchase_fill_count` int(11) NOT NULL DEFAULT 0,
  `is_below_threshold` bit(1) NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `threshold_id`(`threshold_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__thres__5C8CB268` FOREIGN KEY (`threshold_id`) REFERENCES `common_jp_equipment_threshold` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_fix_receive_apply
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_fix_receive_apply`;
CREATE TABLE `common_jp_fix_receive_apply`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `action` int(11) NOT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `apply_time` datetime NOT NULL,
  `approval_result` int(11) NULL DEFAULT NULL,
  `approval_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_time` datetime NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `note` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_code` varchar(40) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_msg` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_state` int(11) NULL DEFAULT NULL,
  `apply_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `process_current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isAfter` bit(1) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `process_current_id`(`process_current_id`) USING BTREE,
  CONSTRAINT `common_jp_fix_receive_apply_ibfk_2` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_receive_apply_ibfk_4` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_receive_apply_ibfk_5` FOREIGN KEY (`process_current_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_fix_receive_apply_detail
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_fix_receive_apply_detail`;
CREATE TABLE `common_jp_fix_receive_apply_detail`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `quantity` int(11) NULL DEFAULT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `order_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `epc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `state` int(11) NULL DEFAULT NULL,
  `real_count` int(11) NULL DEFAULT NULL,
  `inside_real_count` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `order_id`(`order_id`) USING BTREE,
  CONSTRAINT `common_jp_fix_receive_apply_detail_ibfk_1` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_receive_apply_detail_ibfk_2` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_receive_apply_detail_ibfk_3` FOREIGN KEY (`order_id`) REFERENCES `common_jp_fix_receive_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_receive_apply_detail_ibfk_4` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_fix_useless
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_fix_useless`;
CREATE TABLE `common_jp_fix_useless`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `estimate_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `action` int(11) NOT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `fix_time` datetime NOT NULL,
  `create_time` datetime NOT NULL,
  `create_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `note` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_code` varchar(40) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_state` int(11) NULL DEFAULT NULL,
  `isAfter` bit(1) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `estimate_id`(`estimate_id`) USING BTREE,
  CONSTRAINT `common_jp_fix_useless_ibfk_3` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_useless_ibfk_5` FOREIGN KEY (`estimate_id`) REFERENCES `common_jp_fix_receive_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_useless_ibfk_6` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_fix_useless_detail
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_fix_useless_detail`;
CREATE TABLE `common_jp_fix_useless_detail`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `order_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `state` int(11) NULL DEFAULT NULL,
  `quantity` int(11) NULL DEFAULT NULL,
  `epc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `real_count` int(11) NULL DEFAULT 0,
  `inside_real_count` int(11) NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `order_id`(`order_id`) USING BTREE,
  CONSTRAINT `common_jp_fix_useless_detail_ibfk_3` FOREIGN KEY (`order_id`) REFERENCES `common_jp_fix_useless` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_useless_detail_ibfk_4` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_useless_detail_ibfk_5` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_fix_useless_detail_ibfk_6` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_inventory_detail
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_inventory_detail`;
CREATE TABLE `common_jp_inventory_detail`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `state` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `inv_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `table_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `inv_id`(`inv_id`) USING BTREE,
  INDEX `table_id`(`table_id`) USING BTREE,
  CONSTRAINT `FK_common_jp_inventory_detail_base_jp_warehouse` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_detail_common_jp_equipment_inventory` FOREIGN KEY (`inv_id`) REFERENCES `common_jp_equipment_inventory` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_detail_common_jp_inventory_table` FOREIGN KEY (`table_id`) REFERENCES `common_jp_inventory_table` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_inventory_return_apply
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_inventory_return_apply`;
CREATE TABLE `common_jp_inventory_return_apply`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `apply_time` datetime NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `note` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_code` varchar(40) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_state` int(11) NULL DEFAULT NULL,
  `apply_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `process_current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `process_current_id`(`process_current_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__org_i__62458BBE` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__proce__61516785` FOREIGN KEY (`process_current_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__wareh__605D434C` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_inventory_return_apply_detail
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_inventory_return_apply_detail`;
CREATE TABLE `common_jp_inventory_return_apply_detail`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `quantity` int(11) NULL DEFAULT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `order_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `epc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `state` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `order_id`(`order_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__equip__6521F869` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__order__670A40DB` FOREIGN KEY (`order_id`) REFERENCES `common_jp_inventory_return_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__size___66161CA2` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK__common_jp__suppl__67FE6514` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_inventory_table
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_inventory_table`;
CREATE TABLE `common_jp_inventory_table`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `order_no` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `user_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `updateTime` datetime NOT NULL,
  `action_state` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `process_current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `shelfId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `side` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `line` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `column` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `detailId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sizeId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `detailId`(`detailId`) USING BTREE,
  INDEX `sizeId`(`sizeId`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `shelfId`(`shelfId`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `process_current_id`(`process_current_id`) USING BTREE,
  INDEX `user_id`(`user_id`) USING BTREE,
  CONSTRAINT `FK_common_jp_inventory_table_base_jp_equipment_detail` FOREIGN KEY (`detailId`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_table_base_jp_equipment_size` FOREIGN KEY (`sizeId`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_table_base_jp_shelf_info` FOREIGN KEY (`shelfId`) REFERENCES `base_jp_shelf_info` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_table_base_jp_warehouse` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_table_common_jp_inventory_table` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_table_common_jp_inventory_table1` FOREIGN KEY (`process_current_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_inventory_table_common_jp_user` FOREIGN KEY (`user_id`) REFERENCES `common_jp_user` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_log
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_log`;
CREATE TABLE `common_jp_log`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ware_house_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `organization_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `log_detail` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `organization_code`(`organization_code`) USING BTREE,
  INDEX `ware_house_code`(`ware_house_code`) USING BTREE,
  CONSTRAINT `common_jp_log_ibfk_1` FOREIGN KEY (`ware_house_code`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_log_ibfk_2` FOREIGN KEY (`organization_code`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_log_cfg
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_log_cfg`;
CREATE TABLE `common_jp_log_cfg`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `updateCicle` int(11) NOT NULL,
  `lastTime` datetime NOT NULL,
  `urlText` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `logUrl` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_message
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_message`;
CREATE TABLE `common_jp_message`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `message_type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `send_name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `message_info` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `send_time` datetime NULL DEFAULT NULL,
  `state` int(11) NULL DEFAULT NULL,
  `pc_number` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `IX_common_jp_message`(`send_name`) USING BTREE,
  INDEX `NonClusteredIndex-20201126-111741`(`send_name`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_mission
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_mission`;
CREATE TABLE `common_jp_mission`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(126) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_work` bit(1) NULL DEFAULT NULL,
  `state` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  CONSTRAINT `FK_common_jp_mission_base_jp_organization` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_mission_base_jp_warehouse` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_misssion_child
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_misssion_child`;
CREATE TABLE `common_jp_misssion_child`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `mission_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `state` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `model_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `model_id`(`model_id`) USING BTREE,
  INDEX `mission_id`(`mission_id`) USING BTREE,
  CONSTRAINT `FK_common_jp_misssion_child_base_jp_model` FOREIGN KEY (`model_id`) REFERENCES `base_jp_model` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_misssion_child_common_jp_mission` FOREIGN KEY (`mission_id`) REFERENCES `common_jp_mission` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_model_bag
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_model_bag`;
CREATE TABLE `common_jp_model_bag`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `model_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `bag_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `count` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `bag_id`(`bag_id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `model_id`(`model_id`) USING BTREE,
  CONSTRAINT `FK_common_jp_model_bag_base_jp_bag` FOREIGN KEY (`bag_id`) REFERENCES `base_jp_bag` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_model_bag_base_jp_equipment_detail` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_model_bag_base_jp_model` FOREIGN KEY (`model_id`) REFERENCES `base_jp_model` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_process_current
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_process_current`;
CREATE TABLE `common_jp_process_current`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `order_id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `user_type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `user_info` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `data_scope` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `next_step_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_step_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_state` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `action_type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `NonClusteredIndex-20200901-103358`(`order_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_process_history
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_process_history`;
CREATE TABLE `common_jp_process_history`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `process_current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `audit_user_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `step_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `step_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_type` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `flow_state` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `audit_mind` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `audit_user_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `NonClusteredIndex-20200901-103330`(`process_current_id`) USING BTREE,
  CONSTRAINT `PK_process_current_id` FOREIGN KEY (`process_current_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_purchase_detail
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_purchase_detail`;
CREATE TABLE `common_jp_purchase_detail`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `quantity` int(11) NULL DEFAULT NULL,
  `note` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `real_count` int(11) NULL DEFAULT 0,
  `state` int(11) NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `order_id`(`order_id`) USING BTREE,
  CONSTRAINT `FK_common_jp_purchase_detail_base_jp_equipment_detail` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_purchase_detail_base_jp_equipment_size` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_purchase_detail_common_jp_purchase_order` FOREIGN KEY (`order_id`) REFERENCES `common_jp_purchase_order` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_supplier_id` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_purchase_epcs
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_purchase_epcs`;
CREATE TABLE `common_jp_purchase_epcs`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `epc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `detailId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `currentState` int(11) NULL DEFAULT NULL,
  `num` int(11) NULL DEFAULT NULL,
  `createTime` datetime NULL DEFAULT NULL,
  `warrantyCycle` int(11) NULL DEFAULT NULL,
  `repairCycle` int(11) NULL DEFAULT NULL,
  `productTime` datetime NULL DEFAULT NULL,
  `useTime` datetime NULL DEFAULT NULL,
  `price` decimal(12, 2) NULL DEFAULT NULL,
  `useDirection` int(11) NULL DEFAULT NULL,
  `supplierName` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplierId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `shelfId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `shelf_row` int(11) NULL DEFAULT NULL,
  `shelf_column` int(11) NULL DEFAULT NULL,
  `shelf_range` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `supplierId`(`supplierId`) USING BTREE,
  INDEX `detailId`(`detailId`) USING BTREE,
  CONSTRAINT `FK__common_jp__suppl__32616E72` FOREIGN KEY (`supplierId`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_purchase_epcs_ibfk_1` FOREIGN KEY (`detailId`) REFERENCES `common_jp_purchase_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_purchase_order
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_purchase_order`;
CREATE TABLE `common_jp_purchase_order`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `title` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_time` datetime NULL DEFAULT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `target_warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_reason` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_result` int(11) NULL DEFAULT NULL,
  `approval_time` datetime NULL DEFAULT NULL,
  `approval_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `note` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_code` varchar(40) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `org_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_msg` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_state` int(11) NULL DEFAULT NULL,
  `apply_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `process_current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `print_order_code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '打印单单据号',
  `print_order_time` datetime NULL DEFAULT NULL COMMENT '打印单单据时间（第一次创建打印单时间）',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `org_id`(`org_id`) USING BTREE,
  INDEX `target_warehouse_id`(`target_warehouse_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `process_current_id`(`process_current_id`) USING BTREE,
  CONSTRAINT `FK_common_jp_purchase_order_base_jp_organization` FOREIGN KEY (`org_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_purchase_order_base_jp_warehouse` FOREIGN KEY (`target_warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_purchase_order_base_jp_warehouse1` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_purchase_order_common_jp_process_current` FOREIGN KEY (`process_current_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_temp_equipment
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_temp_equipment`;
CREATE TABLE `common_jp_temp_equipment`  (
  `id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `code` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `currnet_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `detail_id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `epc_type` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_code` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `short_name` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `unit` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_id`(`equipment_id`) USING BTREE,
  INDEX `currnet_id`(`currnet_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__equip__6EAB62A3` FOREIGN KEY (`equipment_id`) REFERENCES `base_jp_equipment_info` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `FK_common_jp_temp_equipment_common_jp_process_current` FOREIGN KEY (`currnet_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_temp_equipment_supplier
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_temp_equipment_supplier`;
CREATE TABLE `common_jp_temp_equipment_supplier`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `supplier_code` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_tmp_info
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_tmp_info`;
CREATE TABLE `common_jp_tmp_info`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `orderId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `orderType` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equStateId` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `direction` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equStateId`(`equStateId`) USING BTREE,
  CONSTRAINT `FK_common_jp_tmp_info_common_jp_equipment_state` FOREIGN KEY (`equStateId`) REFERENCES `common_jp_equipment_state` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_transfer
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_transfer`;
CREATE TABLE `common_jp_transfer`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `action_type` int(11) NULL DEFAULT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `receive_orgization_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `send_orgization_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `send_warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `receive_warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `current_state` int(11) NOT NULL,
  `finish_time` datetime NULL DEFAULT NULL,
  `order` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NOT NULL,
  `update_time` datetime NOT NULL,
  `update_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isAfter` bit(1) NULL DEFAULT NULL,
  `is_work` bit(1) NOT NULL DEFAULT b'0',
  `print_order_code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '打印单单据号',
  `print_order_time` datetime NULL DEFAULT NULL COMMENT '打印单单据时间（第一次创建打印单时间）',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `receive_orgization_id`(`receive_orgization_id`) USING BTREE,
  INDEX `send_orgization_id`(`send_orgization_id`) USING BTREE,
  INDEX `send_warehouse_id`(`send_warehouse_id`) USING BTREE,
  INDEX `receive_warehouse_id`(`receive_warehouse_id`) USING BTREE,
  INDEX `apply_id`(`apply_id`) USING BTREE,
  CONSTRAINT `common_jp_transfer_ibfk_1` FOREIGN KEY (`receive_orgization_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_ibfk_2` FOREIGN KEY (`send_orgization_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_ibfk_3` FOREIGN KEY (`send_warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_ibfk_4` FOREIGN KEY (`receive_warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_ibfk_5` FOREIGN KEY (`apply_id`) REFERENCES `common_jp_transfer_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_transfer_apply
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_transfer_apply`;
CREATE TABLE `common_jp_transfer_apply`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `borrow_order_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `action_type` int(11) NULL DEFAULT NULL,
  `transfer_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `target_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `transfer_warehouse` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reason` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `apply_time` datetime NOT NULL,
  `approval_result` int(11) NULL DEFAULT NULL,
  `approval_person` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_msg` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `approval_time` datetime NULL DEFAULT NULL,
  `apply_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_time` datetime NOT NULL,
  `create_time` datetime NOT NULL,
  `create_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `apply_user_name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_user` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `approval_user_name` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `isAfter` bit(1) NULL DEFAULT NULL,
  `process_current_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `expectedReturnTime` date NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `transfer_id`(`transfer_id`) USING BTREE,
  INDEX `target_id`(`target_id`) USING BTREE,
  INDEX `apply_id`(`apply_id`) USING BTREE,
  INDEX `approval_person`(`approval_person`) USING BTREE,
  INDEX `transfer_warehouse`(`transfer_warehouse`) USING BTREE,
  INDEX `process_current_id`(`process_current_id`) USING BTREE,
  CONSTRAINT `common_jp_transfer_apply_ibfk_2` FOREIGN KEY (`transfer_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_apply_ibfk_3` FOREIGN KEY (`target_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_apply_ibfk_4` FOREIGN KEY (`transfer_warehouse`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_apply_ibfk_5` FOREIGN KEY (`approval_person`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_apply_ibfk_6` FOREIGN KEY (`apply_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_apply_ibfk_7` FOREIGN KEY (`process_current_id`) REFERENCES `common_jp_process_current` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_transfer_detail_estimate
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_transfer_detail_estimate`;
CREATE TABLE `common_jp_transfer_detail_estimate`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `estimate_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `equipment_detail_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_count` int(11) NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_detail_id`(`equipment_detail_id`) USING BTREE,
  INDEX `equipment_size_id`(`equipment_size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `estimate_id`(`estimate_id`) USING BTREE,
  CONSTRAINT `common_jp_transfer_detail_estimate_ibfk_1` FOREIGN KEY (`estimate_id`) REFERENCES `common_jp_transfer_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_estimate_ibfk_2` FOREIGN KEY (`equipment_size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_estimate_ibfk_3` FOREIGN KEY (`equipment_detail_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_estimate_ibfk_4` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_transfer_detail_reality
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_transfer_detail_reality`;
CREATE TABLE `common_jp_transfer_detail_reality`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `size_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `estimate_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reality_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `Sort` int(11) NULL DEFAULT NULL,
  `state` int(11) NULL DEFAULT NULL,
  `supplier_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `equipment_detail_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `equipment_count` int(11) NOT NULL DEFAULT 0,
  `real_count` int(11) NOT NULL DEFAULT 0,
  `received_warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehouse_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `inside_real_count` int(11) NULL DEFAULT NULL,
  `is_work` bit(1) NULL DEFAULT b'0',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `equipment_detail_id`(`equipment_detail_id`) USING BTREE,
  INDEX `size_id`(`size_id`) USING BTREE,
  INDEX `supplier_id`(`supplier_id`) USING BTREE,
  INDEX `warehouse_id`(`warehouse_id`) USING BTREE,
  INDEX `received_warehouse_id`(`received_warehouse_id`) USING BTREE,
  INDEX `reality_id`(`reality_id`) USING BTREE,
  INDEX `estimate_id`(`estimate_id`) USING BTREE,
  CONSTRAINT `common_jp_transfer_detail_reality_ibfk_2` FOREIGN KEY (`reality_id`) REFERENCES `common_jp_transfer` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_reality_ibfk_3` FOREIGN KEY (`equipment_detail_id`) REFERENCES `base_jp_equipment_detail` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_reality_ibfk_4` FOREIGN KEY (`estimate_id`) REFERENCES `common_jp_transfer_apply` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_reality_ibfk_5` FOREIGN KEY (`size_id`) REFERENCES `base_jp_equipment_size` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_reality_ibfk_6` FOREIGN KEY (`supplier_id`) REFERENCES `base_jp_supplier` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_reality_ibfk_7` FOREIGN KEY (`warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_transfer_detail_reality_ibfk_8` FOREIGN KEY (`received_warehouse_id`) REFERENCES `base_jp_warehouse` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_user
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_user`;
CREATE TABLE `common_jp_user`  (
  `id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `avatar_id` int(11) NULL DEFAULT NULL,
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `enabled` int(11) NULL DEFAULT NULL,
  `password` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `username` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dept_id` int(11) NULL DEFAULT NULL,
  `phone` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `job_id` int(11) NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `last_password_reset_time` datetime NULL DEFAULT NULL,
  `nick_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sex` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `organization_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `token` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `police_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `organization_id`(`organization_id`) USING BTREE,
  INDEX `police_id`(`police_id`) USING BTREE,
  INDEX `dept_id`(`dept_id`) USING BTREE,
  INDEX `job_id`(`job_id`) USING BTREE,
  INDEX `avatar_id`(`avatar_id`) USING BTREE,
  CONSTRAINT `FK__common_jp__polic__7869D707` FOREIGN KEY (`police_id`) REFERENCES `base_jp_policeman` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_user_ibfk_1` FOREIGN KEY (`dept_id`) REFERENCES `dept` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_user_ibfk_2` FOREIGN KEY (`job_id`) REFERENCES `job` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_user_ibfk_3` FOREIGN KEY (`avatar_id`) REFERENCES `user_avatar` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `common_jp_user_ibfk_4` FOREIGN KEY (`organization_id`) REFERENCES `base_jp_organization` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for common_jp_user_info
-- ----------------------------
DROP TABLE IF EXISTS `common_jp_user_info`;
CREATE TABLE `common_jp_user_info`  (
  `id` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `username` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `txt` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `createTime` datetime NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for dept
-- ----------------------------
DROP TABLE IF EXISTS `dept`;
CREATE TABLE `dept`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `pid` int(11) NOT NULL,
  `enabled` bit(1) NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for dict
-- ----------------------------
DROP TABLE IF EXISTS `dict`;
CREATE TABLE `dict`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 11 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for dict_detail
-- ----------------------------
DROP TABLE IF EXISTS `dict_detail`;
CREATE TABLE `dict_detail`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `label` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `value` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `sort` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dict_id` int(11) NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `dict_id`(`dict_id`) USING BTREE,
  CONSTRAINT `dict_detail_ibfk_1` FOREIGN KEY (`dict_id`) REFERENCES `dict` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB AUTO_INCREMENT = 41 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for email_config
-- ----------------------------
DROP TABLE IF EXISTS `email_config`;
CREATE TABLE `email_config`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `from_user` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `host` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pass` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `port` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `user` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for gen_config
-- ----------------------------
DROP TABLE IF EXISTS `gen_config`;
CREATE TABLE `gen_config`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `author` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cover` bit(1) NULL DEFAULT NULL,
  `module_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pack` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `api_path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `prefix` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `api_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `table_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for job
-- ----------------------------
DROP TABLE IF EXISTS `job`;
CREATE TABLE `job`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `enabled` bit(1) NOT NULL,
  `sort` int(11) NOT NULL,
  `dept_id` int(11) NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `dept_id`(`dept_id`) USING BTREE,
  CONSTRAINT `job_ibfk_1` FOREIGN KEY (`dept_id`) REFERENCES `dept` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for local_storage
-- ----------------------------
DROP TABLE IF EXISTS `local_storage`;
CREATE TABLE `local_storage`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `real_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `suffix` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `operate` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for menu
-- ----------------------------
DROP TABLE IF EXISTS `menu`;
CREATE TABLE `menu`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `i_frame` bit(1) NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `component` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pid` int(11) NOT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `icon` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cache` bit(1) NULL DEFAULT NULL,
  `hidden` bit(1) NULL DEFAULT NULL,
  `component_name` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `permission` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 188 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for mnt_app
-- ----------------------------
DROP TABLE IF EXISTS `mnt_app`;
CREATE TABLE `mnt_app`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `backup_path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `deploy_path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `deploy_script` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `port` int(11) NULL DEFAULT NULL,
  `start_script` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `upload_path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for mnt_database
-- ----------------------------
DROP TABLE IF EXISTS `mnt_database`;
CREATE TABLE `mnt_database`  (
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `jdbc_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `pwd` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `user_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for mnt_deploy
-- ----------------------------
DROP TABLE IF EXISTS `mnt_deploy`;
CREATE TABLE `mnt_deploy`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `create_time` datetime NULL DEFAULT NULL,
  `app_id` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `app_id`(`app_id`) USING BTREE,
  CONSTRAINT `mnt_deploy_ibfk_1` FOREIGN KEY (`app_id`) REFERENCES `mnt_app` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for mnt_deploy_history
-- ----------------------------
DROP TABLE IF EXISTS `mnt_deploy_history`;
CREATE TABLE `mnt_deploy_history`  (
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `app_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `deploy_date` datetime NULL DEFAULT NULL,
  `deploy_id` int(11) NOT NULL,
  `deploy_user` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `ip` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for mnt_deploy_server
-- ----------------------------
DROP TABLE IF EXISTS `mnt_deploy_server`;
CREATE TABLE `mnt_deploy_server`  (
  `deploy_id` int(11) NOT NULL,
  `server_id` int(11) NOT NULL,
  PRIMARY KEY (`deploy_id`, `server_id`) USING BTREE,
  INDEX `server_id`(`server_id`) USING BTREE,
  CONSTRAINT `mnt_deploy_server_ibfk_1` FOREIGN KEY (`deploy_id`) REFERENCES `mnt_deploy` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `mnt_deploy_server_ibfk_2` FOREIGN KEY (`server_id`) REFERENCES `mnt_server` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for mnt_server
-- ----------------------------
DROP TABLE IF EXISTS `mnt_server`;
CREATE TABLE `mnt_server`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `account` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `ip` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `password` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `port` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for monitor_server
-- ----------------------------
DROP TABLE IF EXISTS `monitor_server`;
CREATE TABLE `monitor_server`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `address` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cpu_core` int(11) NULL DEFAULT NULL,
  `cpu_rate` double NULL DEFAULT NULL,
  `disk_total` double NULL DEFAULT NULL,
  `disk_used` double NULL DEFAULT NULL,
  `mem_total` double NULL DEFAULT NULL,
  `mem_used` double NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `port` int(11) NULL DEFAULT NULL,
  `sort` int(11) NULL DEFAULT NULL,
  `state` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `swap_total` double NULL DEFAULT NULL,
  `swap_used` double NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for picture
-- ----------------------------
DROP TABLE IF EXISTS `picture`;
CREATE TABLE `picture`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `create_time` datetime NULL DEFAULT NULL,
  `delete_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `filename` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `height` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `username` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `width` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `md5code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for qiniu_config
-- ----------------------------
DROP TABLE IF EXISTS `qiniu_config`;
CREATE TABLE `qiniu_config`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `access_key` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `bucket` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `host` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `secret_key` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `zone` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for qiniu_content
-- ----------------------------
DROP TABLE IF EXISTS `qiniu_content`;
CREATE TABLE `qiniu_content`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `bucket` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_time` datetime NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `suffix` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for quartz_job
-- ----------------------------
DROP TABLE IF EXISTS `quartz_job`;
CREATE TABLE `quartz_job`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `bean_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cron_expression` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_pause` bit(1) NULL DEFAULT NULL,
  `job_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `method_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `params` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 4 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for quartz_log
-- ----------------------------
DROP TABLE IF EXISTS `quartz_log`;
CREATE TABLE `quartz_log`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `baen_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `cron_expression` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `exception_detail` longtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `is_success` bit(1) NULL DEFAULT NULL,
  `job_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `method_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `params` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `time` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for role
-- ----------------------------
DROP TABLE IF EXISTS `role`;
CREATE TABLE `role`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `data_scope` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `level` int(11) NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `permission` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 7 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for roles_depts
-- ----------------------------
DROP TABLE IF EXISTS `roles_depts`;
CREATE TABLE `roles_depts`  (
  `role_id` int(11) NOT NULL,
  `dept_id` int(11) NOT NULL,
  PRIMARY KEY (`dept_id`, `role_id`) USING BTREE,
  INDEX `role_id`(`role_id`) USING BTREE,
  CONSTRAINT `roles_depts_ibfk_1` FOREIGN KEY (`dept_id`) REFERENCES `dept` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `roles_depts_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `role` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for roles_menus
-- ----------------------------
DROP TABLE IF EXISTS `roles_menus`;
CREATE TABLE `roles_menus`  (
  `menu_id` int(11) NOT NULL,
  `role_id` int(11) NOT NULL,
  PRIMARY KEY (`menu_id`, `role_id`) USING BTREE,
  INDEX `role_id`(`role_id`) USING BTREE,
  CONSTRAINT `roles_menus_ibfk_1` FOREIGN KEY (`menu_id`) REFERENCES `menu` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `roles_menus_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `role` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for user_avatar
-- ----------------------------
DROP TABLE IF EXISTS `user_avatar`;
CREATE TABLE `user_avatar`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `real_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `path` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `size` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for users_roles
-- ----------------------------
DROP TABLE IF EXISTS `users_roles`;
CREATE TABLE `users_roles`  (
  `user_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `role_id` int(11) NOT NULL,
  PRIMARY KEY (`role_id`, `user_id`) USING BTREE,
  INDEX `user_id`(`user_id`) USING BTREE,
  CONSTRAINT `users_roles_ibfk_1` FOREIGN KEY (`role_id`) REFERENCES `role` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT,
  CONSTRAINT `users_roles_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `common_jp_user` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for verification_code
-- ----------------------------
DROP TABLE IF EXISTS `verification_code`;
CREATE TABLE `verification_code`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime NULL DEFAULT NULL,
  `status` bit(1) NULL DEFAULT NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `value` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `scenes` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = latin1 COLLATE = latin1_swedish_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- Table structure for visits
-- ----------------------------
DROP TABLE IF EXISTS `visits`;
CREATE TABLE `visits`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `create_time` datetime NULL DEFAULT NULL,
  `date` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `ip_counts` int(11) NULL DEFAULT NULL,
  `pv_counts` int(11) NULL DEFAULT NULL,
  `week_day` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 10 CHARACTER SET = latin1 COLLATE = latin1_swedish_ci ROW_FORMAT = DYNAMIC;

-- ----------------------------
-- View structure for view_all_order
-- ----------------------------
DROP VIEW IF EXISTS `view_all_order`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_all_order` AS select `base_jp_warehouse`.`name` AS `warehouseName`,`common_jp_purchase_order`.`create_time` AS `CreateTime`,`common_jp_purchase_order`.`order_code` AS `OrderNo`,`common_jp_process_current`.`flow_name` AS `flow_name`,`common_jp_process_current`.`flow_state` AS `flow_state`,`common_jp_process_current`.`org_id` AS `org_id`,`common_jp_process_current`.`update_time` AS `update_time`,`common_jp_process_current`.`flow_type` AS `flow_type`,`common_jp_process_current`.`user_type` AS `user_type`,`common_jp_process_current`.`user_info` AS `user_info`,`common_jp_process_current`.`data_scope` AS `data_scope`,`common_jp_process_current`.`order_id` AS `order_id` from ((`common_jp_process_current` join `common_jp_purchase_order` on((`common_jp_purchase_order`.`id` = `common_jp_process_current`.`order_id`))) join `base_jp_warehouse` on((`common_jp_purchase_order`.`warehouse_id` = `base_jp_warehouse`.`id`))) where ((`common_jp_process_current`.`user_type` is not null) and (`common_jp_process_current`.`user_type` <> '') and (`common_jp_process_current`.`user_info` is not null) and (`common_jp_process_current`.`flow_state` = 'false')) union select `base_jp_warehouse`.`name` AS `warehouseName`,`common_jp_transfer_apply`.`create_time` AS `CreateTime`,`common_jp_transfer_apply`.`order` AS `OrderNo`,`common_jp_process_current`.`flow_name` AS `flow_name`,`common_jp_process_current`.`flow_state` AS `flow_state`,`common_jp_process_current`.`org_id` AS `org_id`,`common_jp_process_current`.`update_time` AS `update_time`,`common_jp_process_current`.`flow_type` AS `flow_type`,`common_jp_process_current`.`user_type` AS `user_type`,`common_jp_process_current`.`user_info` AS `user_info`,`common_jp_process_current`.`data_scope` AS `data_scope`,`common_jp_process_current`.`order_id` AS `order_id` from ((`common_jp_process_current` join `common_jp_transfer_apply` on((`common_jp_transfer_apply`.`id` = `common_jp_process_current`.`order_id`))) join `base_jp_warehouse` on((`common_jp_transfer_apply`.`transfer_warehouse` = `base_jp_warehouse`.`id`))) where ((`common_jp_process_current`.`user_type` is not null) and (`common_jp_process_current`.`user_type` <> '') and (`common_jp_process_current`.`flow_state` = 'false')) union select `base_jp_warehouse`.`name` AS `warehouseName`,`common_jp_borrow_return_apply`.`create_time` AS `CreateTime`,`common_jp_borrow_return_apply`.`order_code` AS `OrderNo`,`common_jp_process_current`.`flow_name` AS `flow_name`,`common_jp_process_current`.`flow_state` AS `flow_state`,`common_jp_process_current`.`org_id` AS `org_id`,`common_jp_process_current`.`update_time` AS `update_time`,`common_jp_process_current`.`flow_type` AS `flow_type`,`common_jp_process_current`.`user_type` AS `user_type`,`common_jp_process_current`.`user_info` AS `user_info`,`common_jp_process_current`.`data_scope` AS `data_scope`,`common_jp_process_current`.`order_id` AS `order_id` from ((`common_jp_process_current` join `common_jp_borrow_return_apply` on((`common_jp_borrow_return_apply`.`id` = `common_jp_process_current`.`order_id`))) join `base_jp_warehouse` on((`common_jp_borrow_return_apply`.`warehouse_id` = `base_jp_warehouse`.`id`))) where ((`common_jp_process_current`.`user_type` is not null) and (`common_jp_process_current`.`user_type` <> '') and (`common_jp_process_current`.`flow_state` = 'false')) union select `base_jp_warehouse`.`name` AS `warehouseName`,`common_jp_fix_receive_apply`.`create_time` AS `CreateTime`,`common_jp_fix_receive_apply`.`order_code` AS `OrderNo`,`common_jp_process_current`.`flow_name` AS `flow_name`,`common_jp_process_current`.`flow_state` AS `flow_state`,`common_jp_process_current`.`org_id` AS `org_id`,`common_jp_process_current`.`update_time` AS `update_time`,`common_jp_process_current`.`flow_type` AS `flow_type`,`common_jp_process_current`.`user_type` AS `user_type`,`common_jp_process_current`.`user_info` AS `user_info`,`common_jp_process_current`.`data_scope` AS `data_scope`,`common_jp_process_current`.`order_id` AS `order_id` from ((`common_jp_process_current` join `common_jp_fix_receive_apply` on((`common_jp_fix_receive_apply`.`id` = `common_jp_process_current`.`order_id`))) join `base_jp_warehouse` on((`common_jp_fix_receive_apply`.`warehouse_id` = `base_jp_warehouse`.`id`))) where ((`common_jp_process_current`.`user_type` is not null) and (`common_jp_process_current`.`user_type` <> '') and (`common_jp_process_current`.`flow_state` = 'false'));

-- ----------------------------
-- View structure for view_bf_p
-- ----------------------------
DROP VIEW IF EXISTS `view_bf_p`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_bf_p` AS select `tablesum`.`org_id` AS `org_id`,`tablesum`.`org_name` AS `org_name`,`tablesum`.`area_name` AS `area_name`,`tablesum`.`warehouse_name` AS `warehouse_name`,`tablesum`.`warehouse_code` AS `warehouse_code`,`tablesum`.`size_id` AS `size_id`,`tablesum`.`equ_name` AS `equ_name`,`tablesum`.`size_code` AS `size_code`,`tablesum`.`size_name` AS `size_name`,`tablesum`.`sizeCount` AS `sizeCount`,cast(round(((cast(coalesce(`table7`.`weekCount`,0) as decimal(20,2)) / cast(coalesce(ifnull(`tablesum`.`sizeCount`,0),1) as decimal(20,2))) * 100),2) as decimal(10,0)) AS `weekP`,cast(round(((cast(coalesce(`table30`.`monthCount`,0) as decimal(20,2)) / cast(coalesce(nullif(`tablesum`.`sizeCount`,0),1) as decimal(20,2))) * 100),2) as decimal(10,0)) AS `monthP` from ((((select `a`.`org_id` AS `org_id`,`a`.`org_name` AS `org_name`,`a`.`area_name` AS `area_name`,`a`.`warehouse_name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`size_id` AS `size_id`,`a`.`equ_name` AS `equ_name`,`a`.`size_code` AS `size_code`,`a`.`size_name` AS `size_name`,count(`a`.`current_state`) AS `sizeCount` from (select `d`.`id` AS `org_id`,`d`.`name` AS `org_name`,`d`.`area_name` AS `area_name`,`c`.`name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`current_state` AS `current_state`,`b`.`size_id` AS `size_id`,`b`.`equ_name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (((`junmppolicesql`.`common_jp_equipment_inventory` `a` left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `b` on((`a`.`equipment_sizecode` = `b`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `c` on((`a`.`warehouse_code` = `c`.`id`))) left join `junmppolicesql`.`base_jp_organization` `d` on((`c`.`orgization_id` = `d`.`id`)))) `a` group by `a`.`org_id`,`a`.`org_name`,`a`.`area_name`,`a`.`warehouse_name`,`a`.`warehouse_code`,`a`.`size_id`,`a`.`equ_name`,`a`.`size_code`,`a`.`size_name`)) `tablesum` left join (select `e`.`id` AS `org_id`,`e`.`name` AS `org_name`,`e`.`area_name` AS `area_name`,`d`.`name` AS `warehouse_name`,`a`.`warehouse_id` AS `warehouse_code`,`c`.`size_id` AS `size_id`,`c`.`equ_name` AS `equ_name`,`c`.`size_code` AS `size_code`,`c`.`size_name` AS `size_name`,count(`e`.`id`) AS `weekCount` from ((((`junmppolicesql`.`common_jp_fix_useless` `a` left join `junmppolicesql`.`common_jp_fix_useless_detail` `b` on((`b`.`order_id` = `a`.`id`))) left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `c` on((`b`.`size_id` = `c`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `d` on((`a`.`warehouse_id` = `d`.`id`))) left join `junmppolicesql`.`base_jp_organization` `e` on((`d`.`orgization_id` = `e`.`id`))) where ((timestampdiff(DAY,`a`.`fix_time`,now()) <= 7) and (`a`.`action` = 1)) group by `e`.`id`,`e`.`name`,`e`.`area_name`,`d`.`name`,`a`.`warehouse_id`,`c`.`size_id`,`c`.`equ_name`,`c`.`size_code`,`c`.`size_name`) `table7` on(((`tablesum`.`org_id` = `table7`.`org_id`) and (`tablesum`.`warehouse_code` = `table7`.`warehouse_code`) and (`tablesum`.`size_id` = `table7`.`size_id`)))) left join (select `e`.`id` AS `org_id`,`e`.`name` AS `org_name`,`e`.`area_name` AS `area_name`,`d`.`name` AS `warehouse_name`,`a`.`warehouse_id` AS `warehouse_code`,`c`.`size_id` AS `size_id`,`c`.`equ_name` AS `equ_name`,`c`.`size_code` AS `size_code`,`c`.`size_name` AS `size_name`,count(`e`.`id`) AS `monthCount` from ((((`junmppolicesql`.`common_jp_fix_useless` `a` left join `junmppolicesql`.`common_jp_fix_useless_detail` `b` on((`b`.`order_id` = `a`.`id`))) left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `c` on((`b`.`size_id` = `c`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `d` on((`a`.`warehouse_id` = `d`.`id`))) left join `junmppolicesql`.`base_jp_organization` `e` on((`d`.`orgization_id` = `e`.`id`))) where ((timestampdiff(DAY,`a`.`fix_time`,now()) <= 30) and (`a`.`action` = 1)) group by `e`.`id`,`e`.`name`,`e`.`area_name`,`d`.`name`,`a`.`warehouse_id`,`c`.`size_id`,`c`.`equ_name`,`c`.`size_code`,`c`.`size_name`) `table30` on(((`tablesum`.`org_id` = `table30`.`org_id`) and (`tablesum`.`warehouse_code` = `table30`.`warehouse_code`) and (`tablesum`.`size_id` = `table30`.`size_id`))));

-- ----------------------------
-- View structure for view_borrow
-- ----------------------------
DROP VIEW IF EXISTS `view_borrow`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_borrow` AS select `a`.`id` AS `org_id`,`a`.`name` AS `org_name`,`a`.`code` AS `org_code`,`a`.`find_code` AS `find_code`,`a`.`area_name` AS `area_name`,`c`.`action_type` AS `action_type`,`d`.`equipment_count` AS `equipment_count`,`d`.`state` AS `state`,`f`.`NAME` AS `equipment_name`,`f`.`parent_name` AS `parent_name` from (((((`junmppolicesql`.`base_jp_organization` `a` left join `junmppolicesql`.`base_jp_warehouse` `b` on((`a`.`id` = `b`.`orgization_id`))) left join `junmppolicesql`.`common_jp_borrow_return` `c` on((`b`.`id` = `c`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_borrow_return_detail_reality` `d` on((`c`.`id` = `d`.`reality_id`))) left join `junmppolicesql`.`base_jp_equipment_detail` `e` on((`d`.`equipment_detail_id` = `e`.`id`))) left join (select `a`.`id` AS `id`,`a`.`name` AS `NAME`,`c`.`name` AS `parent_name` from ((`junmppolicesql`.`base_jp_equipment_info` `a` join `junmppolicesql`.`base_jp_equipment_info` `b` on((`b`.`id` = `a`.`parent_id`))) join `junmppolicesql`.`base_jp_equipment_info` `c` on((`c`.`id` = `b`.`parent_id`)))) `f` on((`e`.`equipment_id` = `f`.`id`))) where (`a`.`state` = '1');

-- ----------------------------
-- View structure for view_equipment
-- ----------------------------
DROP VIEW IF EXISTS `view_equipment`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_equipment` AS select `a`.`id` AS `org_id`,`a`.`name` AS `org_name`,`a`.`code` AS `org_code`,`a`.`find_code` AS `find_code`,`a`.`area_name` AS `area_name`,`c`.`current_state` AS `current_state`,`b`.`id` AS `warehouse_code`,`b`.`name` AS `warehouse_name`,`c`.`equipment_code` AS `equipment_code`,`d`.`name` AS `equipment_name`,`c`.`equipment_sizecode` AS `equipment_sizecode`,`f`.`size_name` AS `size_name`,`e`.`type_one_id` AS `type_one_id`,`e`.`parent_name` AS `parent_name`,`e`.`type_two_id` AS `type_two_id`,`e`.`type_name` AS `type_name`,`e`.`type_three_id` AS `type_three_id`,`e`.`NAME` AS `NAME`,`c`.`price` AS `price`,`c`.`create_time` AS `create_time`,`c`.`inventory_state` AS `inventory_state`,`c`.`safe_level` AS `safe_level`,`a`.`is_map` AS `is_map` from (((((`junmppolicesql`.`base_jp_organization` `a` left join `junmppolicesql`.`base_jp_warehouse` `b` on((`a`.`id` = `b`.`orgization_id`))) left join `junmppolicesql`.`common_jp_equipment_inventory` `c` on((`b`.`id` = `c`.`warehouse_code`))) left join `junmppolicesql`.`base_jp_equipment_detail` `d` on((`c`.`equipment_code` = `d`.`id`))) left join `junmppolicesql`.`base_jp_equipment_size` `f` on((`c`.`equipment_sizecode` = `f`.`id`))) left join (select `a`.`id` AS `type_three_id`,`a`.`name` AS `NAME`,`b`.`name` AS `type_name`,`b`.`id` AS `type_two_id`,`c`.`name` AS `parent_name`,`c`.`id` AS `type_one_id` from ((`junmppolicesql`.`base_jp_equipment_info` `a` join `junmppolicesql`.`base_jp_equipment_info` `b` on((`b`.`id` = `a`.`parent_id`))) join `junmppolicesql`.`base_jp_equipment_info` `c` on((`c`.`id` = `b`.`parent_id`)))) `e` on((`d`.`equipment_id` = `e`.`type_three_id`))) where ((`a`.`state` = '1') and ((`c`.`inventory_state` <> 'loss') or isnull(`c`.`inventory_state`)));

-- ----------------------------
-- View structure for view_equipment_count
-- ----------------------------
DROP VIEW IF EXISTS `view_equipment_count`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_equipment_count` AS select `a`.`org_id` AS `org_id`,`a`.`org_name` AS `org_name`,`a`.`area_name` AS `area_name`,`a`.`warehouse_name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`size_id` AS `size_id`,`a`.`equ_name` AS `equ_name`,`a`.`size_code` AS `size_code`,`a`.`size_name` AS `size_name`,`a`.`parent_name` AS `parent_name`,sum((case when ((`a`.`current_state` = 3) or (`a`.`current_state` = 0)) then 1 else 0 end)) AS `sizeCount`,sum((case when (`a`.`current_state` = 3) then 1 else 0 end)) AS `djgCount` from (select `d`.`id` AS `org_id`,`d`.`name` AS `org_name`,`d`.`area_name` AS `area_name`,`c`.`name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`current_state` AS `current_state`,`b`.`size_id` AS `size_id`,`b`.`equ_name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name`,`e`.`parent_name` AS `parent_name` from ((((`junmppolicesql`.`common_jp_equipment_inventory` `a` left join (select `b`.`id` AS `size_id`,`a`.`equipment_id` AS `equipment_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `b` on((`a`.`equipment_sizecode` = `b`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `c` on((`a`.`warehouse_code` = `c`.`id`))) left join `junmppolicesql`.`base_jp_organization` `d` on((`c`.`orgization_id` = `d`.`id`))) left join (select `a`.`id` AS `id`,`a`.`name` AS `NAME`,`c`.`name` AS `parent_name` from ((`junmppolicesql`.`base_jp_equipment_info` `a` join `junmppolicesql`.`base_jp_equipment_info` `b` on((`b`.`id` = `a`.`parent_id`))) join `junmppolicesql`.`base_jp_equipment_info` `c` on((`c`.`id` = `b`.`parent_id`)))) `e` on((`b`.`equipment_id` = `e`.`id`)))) `a` group by `a`.`org_id`,`a`.`org_name`,`a`.`area_name`,`a`.`warehouse_name`,`a`.`warehouse_code`,`a`.`size_id`,`a`.`equ_name`,`a`.`size_code`,`a`.`size_name`,`a`.`parent_name`;

-- ----------------------------
-- View structure for view_equipment_details
-- ----------------------------
DROP VIEW IF EXISTS `view_equipment_details`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_equipment_details` AS select `c`.`id` AS `id`,`c`.`shelf_column` AS `shelf_column`,`c`.`shelf_range` AS `shelf_range`,`c`.`shelf_row` AS `shelf_row`,`shelf`.`name` AS `shelfName`,`a`.`id` AS `org_id`,`bf`.`fixCount` AS `fixCount`,`t1`.`useCount` AS `useCount`,`c`.`epc` AS `epc`,`c`.`current_state` AS `current_state`,`a`.`name` AS `org_name`,`a`.`code` AS `org_code`,`a`.`find_code` AS `find_code`,`a`.`area_name` AS `area_name`,`c`.`warrantyCycle` AS `warrantyCycle`,`c`.`repairCycle` AS `repairCycle`,`c`.`productTime` AS `productTime`,`supplier`.`name` AS `supplierName`,`b`.`id` AS `warehouseId`,`b`.`name` AS `warehouse_name`,`c`.`equipment_code` AS `equipment_code`,`d`.`name` AS `equipment_name`,`c`.`equipment_sizecode` AS `equipment_sizecode`,`f`.`size_name` AS `size_name`,`e`.`type_one_id` AS `type_one_id`,`e`.`parent_name` AS `parent_name`,`e`.`type_two_id` AS `type_two_id`,`e`.`type_name` AS `type_name`,`e`.`type_three_id` AS `type_three_id`,`e`.`name` AS `name`,`c`.`price` AS `price`,`c`.`create_time` AS `create_time`,`c`.`inventory_state` AS `inventory_state`,`c`.`safe_level` AS `safe_level`,`a`.`is_map` AS `is_map` from (((((((((`junmppolicesql`.`base_jp_organization` `a` left join `junmppolicesql`.`base_jp_warehouse` `b` on((`a`.`id` = `b`.`orgization_id`))) join `junmppolicesql`.`common_jp_equipment_inventory` `c` on((`b`.`id` = `c`.`warehouse_code`))) left join `junmppolicesql`.`base_jp_equipment_detail` `d` on((`c`.`equipment_code` = `d`.`id`))) left join `junmppolicesql`.`base_jp_shelf_info` `shelf` on((`c`.`shelfId` = `shelf`.`id`))) left join `junmppolicesql`.`base_jp_equipment_size` `f` on((`c`.`equipment_sizecode` = `f`.`id`))) left join (select `invs`.`id` AS `id`,count(`states`.`id`) AS `useCount` from (`junmppolicesql`.`common_jp_equipment_inventory` `invs` left join `junmppolicesql`.`common_jp_equipment_state` `states` on((`states`.`eqiupment_id` = `invs`.`id`))) where ((`states`.`out_in_state` = 0) and (`states`.`state` <> 2)) group by `invs`.`id`) `t1` on((`t1`.`id` = `c`.`id`))) left join (select `invs`.`id` AS `id`,count(`states`.`id`) AS `fixCount` from (`junmppolicesql`.`common_jp_equipment_inventory` `invs` left join `junmppolicesql`.`common_jp_equipment_state` `states` on((`states`.`eqiupment_id` = `invs`.`id`))) where (`states`.`action_state` = 6) group by `invs`.`id`) `bf` on((`bf`.`id` = `c`.`id`))) left join `junmppolicesql`.`base_jp_supplier` `supplier` on((`supplier`.`id` = `c`.`supplier_code`))) left join (select `a`.`id` AS `type_three_id`,`a`.`name` AS `name`,`b`.`name` AS `type_name`,`b`.`id` AS `type_two_id`,`c`.`name` AS `parent_name`,`c`.`id` AS `type_one_id` from ((`junmppolicesql`.`base_jp_equipment_info` `a` join `junmppolicesql`.`base_jp_equipment_info` `b` on((`b`.`id` = `a`.`parent_id`))) join `junmppolicesql`.`base_jp_equipment_info` `c` on((`c`.`id` = `b`.`parent_id`)))) `e` on((`d`.`equipment_id` = `e`.`type_three_id`))) where ((`a`.`state` = '1') and ((`c`.`inventory_state` <> 'loss') or isnull(`c`.`inventory_state`)));

-- ----------------------------
-- View structure for view_equipment_location
-- ----------------------------
DROP VIEW IF EXISTS `view_equipment_location`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_equipment_location` AS select `t2`.`counts` AS `counts`,`t2`.`equipment_code` AS `equipment_code`,`t2`.`warehouse_code` AS `warehouse_code`,`t2`.`cabinet_id` AS `cabinet_id`,`t2`.`equipment_sizecode` AS `equipment_sizecode`,`t2`.`current_state` AS `current_state`,`t2`.`cabinetName` AS `cabinetName`,`t2`.`warehouseName` AS `warehouseName`,`t2`.`equipmentName` AS `equipmentName`,`t2`.`equipmentId` AS `equipmentId`,`t2`.`size_name` AS `size_name`,`org1`.`name` AS `warehouseOrgName`,`org2`.`name` AS `cabinetOrgName`,`org1`.`id` AS `warehouseOrgId`,`org2`.`id` AS `cabinetOrgId` from ((((select `t1`.`counts` AS `counts`,`t1`.`equipment_code` AS `equipment_code`,`t1`.`warehouse_code` AS `warehouse_code`,`t1`.`cabinet_real_num` AS `cabinet_id`,`t1`.`equipment_sizecode` AS `equipment_sizecode`,`t1`.`current_state` AS `current_state`,`t1`.`cabinet_num` AS `cabinetName`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`orgization_id` AS `warehouseOrg`,`t1`.`cabinetOrg` AS `cabinetOrg`,`junmppolicesql`.`base_jp_equipment_detail`.`name` AS `equipmentName`,`junmppolicesql`.`base_jp_equipment_detail`.`equipment_id` AS `equipmentId`,`junmppolicesql`.`base_jp_equipment_size`.`size_name` AS `size_name` from (((((select count(0) AS `counts`,`junmppolicesql`.`common_jp_equipment_inventory`.`equipment_code` AS `equipment_code`,`junmppolicesql`.`common_jp_equipment_inventory`.`warehouse_code` AS `warehouse_code`,`junmppolicesql`.`base_jp_cabinet`.`cabinet_real_num` AS `cabinet_real_num`,`junmppolicesql`.`base_jp_cabinet`.`cabinet_num` AS `cabinet_num`,`junmppolicesql`.`base_jp_cabinet`.`organization_id` AS `cabinetOrg`,`junmppolicesql`.`common_jp_equipment_inventory`.`equipment_sizecode` AS `equipment_sizecode`,`junmppolicesql`.`common_jp_equipment_inventory`.`current_state` AS `current_state` from (`junmppolicesql`.`common_jp_equipment_inventory` left join `junmppolicesql`.`base_jp_cabinet` on((`junmppolicesql`.`common_jp_equipment_inventory`.`cabinet_id` = `junmppolicesql`.`base_jp_cabinet`.`id`))) group by `junmppolicesql`.`common_jp_equipment_inventory`.`warehouse_code`,`junmppolicesql`.`common_jp_equipment_inventory`.`equipment_code`,`junmppolicesql`.`common_jp_equipment_inventory`.`equipment_sizecode`,`junmppolicesql`.`base_jp_cabinet`.`cabinet_real_num`,`junmppolicesql`.`base_jp_cabinet`.`organization_id`,`junmppolicesql`.`base_jp_cabinet`.`cabinet_num`,`junmppolicesql`.`common_jp_equipment_inventory`.`current_state`)) `t1` left join `junmppolicesql`.`base_jp_warehouse` on((`t1`.`warehouse_code` = `junmppolicesql`.`base_jp_warehouse`.`id`))) left join `junmppolicesql`.`base_jp_equipment_detail` on((`t1`.`equipment_code` = `junmppolicesql`.`base_jp_equipment_detail`.`id`))) left join `junmppolicesql`.`base_jp_equipment_size` on((`t1`.`equipment_sizecode` = `junmppolicesql`.`base_jp_equipment_size`.`id`))))) `t2` left join `junmppolicesql`.`base_jp_organization` `org1` on((`t2`.`warehouseOrg` = `org1`.`id`))) left join `junmppolicesql`.`base_jp_organization` `org2` on((`t2`.`cabinetOrg` = `org2`.`id`)));

-- ----------------------------
-- View structure for view_equipment_type
-- ----------------------------
DROP VIEW IF EXISTS `view_equipment_type`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_equipment_type` AS select `c`.`warehouse_code` AS `warehouse_id`,`c`.`current_state` AS `current_state`,`d`.`id` AS `equipment_code`,`d`.`name` AS `equipment_name`,`c`.`equipment_sizecode` AS `equipment_sizecode`,`f`.`size_name` AS `size_name`,`e`.`type_one_id` AS `type_one_id`,`e`.`parent_name` AS `parent_name`,`e`.`type_two_id` AS `type_two_id`,`e`.`type_name` AS `type_name`,`e`.`type_three_id` AS `type_three_id`,`e`.`NAME` AS `NAME`,`c`.`price` AS `price`,`c`.`productTime` AS `productTime`,`a`.`id` AS `org_id`,`a`.`name` AS `org_name`,`a`.`code` AS `org_code`,`a`.`find_code` AS `find_code`,`c`.`address` AS `address`,`k`.`name` AS `supplier_name` from ((((((((select `a`.`id` AS `id`,`a`.`id` AS `type_three_id`,`a`.`name` AS `NAME`,(case `b`.`name` when '超级根' then `a`.`name` else `b`.`name` end) AS `type_name`,(case `b`.`name` when '超级根' then `a`.`id` else `b`.`id` end) AS `type_two_id`,(case `c`.`name` when '超级根' then (case `b`.`name` when '超级根' then `a`.`name` else `b`.`name` end) else `c`.`name` end) AS `parent_name`,(case `c`.`name` when '超级根' then (case `b`.`name` when '超级根' then `a`.`id` else `b`.`id` end) else `c`.`id` end) AS `type_one_id` from ((`junmppolicesql`.`base_jp_equipment_info` `a` join `junmppolicesql`.`base_jp_equipment_info` `b` on((`b`.`id` = `a`.`parent_id`))) join `junmppolicesql`.`base_jp_equipment_info` `c` on((`c`.`id` = `b`.`parent_id`))) where (`a`.`id` <> '00000000-0000-0000-0000-000000000000'))) `e` left join `junmppolicesql`.`base_jp_equipment_detail` `d` on((`d`.`equipment_id` = `e`.`id`))) left join `junmppolicesql`.`common_jp_equipment_inventory` `c` on((`c`.`equipment_code` = `d`.`id`))) left join `junmppolicesql`.`base_jp_equipment_size` `f` on((`c`.`equipment_sizecode` = `f`.`id`))) left join `junmppolicesql`.`base_jp_warehouse` `b` on((`b`.`id` = `c`.`warehouse_code`))) left join `junmppolicesql`.`base_jp_organization` `a` on((`a`.`id` = `b`.`orgization_id`))) left join `junmppolicesql`.`base_jp_supplier` `k` on((`c`.`supplier_code` = `k`.`id`))) where ((`c`.`inventory_state` <> 'loss') or isnull(`c`.`inventory_state`));

-- ----------------------------
-- View structure for view_order_state
-- ----------------------------
DROP VIEW IF EXISTS `view_order_state`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_order_state` AS select `common_jp_transfer`.`id` AS `Id`,`common_jp_transfer`.`apply_id` AS `applyId`,`common_jp_transfer`.`current_state` AS `currentState`,`common_jp_transfer`.`order` AS `order`,`common_jp_transfer`.`create_time` AS `createTime`,`common_jp_transfer`.`receive_orgization_id` AS `Orgid`,'调拨' AS `type`,'已完成' AS `State` from (`common_jp_transfer` join `common_jp_process_current` on((`common_jp_transfer`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and ((`common_jp_transfer`.`current_state` = 2) or (`common_jp_transfer`.`current_state` = 3)) and (`common_jp_transfer`.`action_type` = 0)) union select `common_jp_transfer`.`id` AS `Id`,`common_jp_transfer`.`apply_id` AS `applyId`,`common_jp_transfer`.`current_state` AS `currentState`,`common_jp_transfer`.`order` AS `order`,`common_jp_transfer`.`create_time` AS `createTime`,`common_jp_transfer`.`receive_orgization_id` AS `Orgid`,'调拨' AS `type`,'未完成' AS `State` from (`common_jp_transfer` join `common_jp_process_current` on((`common_jp_transfer`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and ((`common_jp_transfer`.`current_state` = 0) or (`common_jp_transfer`.`current_state` = 1)) and (`common_jp_transfer`.`action_type` = 0)) union select `common_jp_transfer`.`id` AS `Id`,`common_jp_transfer`.`apply_id` AS `applyId`,`common_jp_transfer`.`current_state` AS `currentState`,`common_jp_transfer`.`order` AS `order`,`common_jp_transfer`.`create_time` AS `createTime`,`common_jp_transfer`.`receive_orgization_id` AS `Orgid`,'跨库借用' AS `type`,'未完成' AS `State` from (`common_jp_transfer` join `common_jp_process_current` on((`common_jp_transfer`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and ((`common_jp_transfer`.`current_state` = 0) or (`common_jp_transfer`.`current_state` = 1)) and (`common_jp_transfer`.`action_type` = 1)) union select `common_jp_transfer`.`id` AS `Id`,`common_jp_transfer`.`apply_id` AS `applyId`,`common_jp_transfer`.`current_state` AS `currentState`,`common_jp_transfer`.`order` AS `order`,`common_jp_transfer`.`create_time` AS `createTime`,`common_jp_transfer`.`receive_orgization_id` AS `Orgid`,'跨库借用' AS `type`,'已完成' AS `State` from (`common_jp_transfer` join `common_jp_process_current` on((`common_jp_transfer`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and ((`common_jp_transfer`.`current_state` = 2) or (`common_jp_transfer`.`current_state` = 3)) and (`common_jp_transfer`.`action_type` = 1)) union select `common_jp_transfer`.`id` AS `Id`,`common_jp_transfer`.`apply_id` AS `applyId`,`common_jp_transfer`.`current_state` AS `currentState`,`common_jp_transfer`.`order` AS `order`,`common_jp_transfer`.`create_time` AS `createTime`,`common_jp_transfer`.`receive_orgization_id` AS `Orgid`,'跨库归还' AS `type`,'已完成' AS `State` from (`common_jp_transfer` join `common_jp_process_current` on((`common_jp_transfer`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and ((`common_jp_transfer`.`current_state` = 2) or (`common_jp_transfer`.`current_state` = 3)) and (`common_jp_transfer`.`action_type` = 2)) union select `common_jp_transfer`.`id` AS `Id`,`common_jp_transfer`.`apply_id` AS `applyId`,`common_jp_transfer`.`current_state` AS `currentState`,`common_jp_transfer`.`order` AS `order`,`common_jp_transfer`.`create_time` AS `createTime`,`common_jp_transfer`.`receive_orgization_id` AS `Orgid`,'跨库归还' AS `type`,'未完成' AS `State` from (`common_jp_transfer` join `common_jp_process_current` on((`common_jp_transfer`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and ((`common_jp_transfer`.`current_state` = 0) or (`common_jp_transfer`.`current_state` = 1)) and (`common_jp_transfer`.`action_type` = 2)) union select `common_jp_borrow_return`.`id` AS `Id`,`common_jp_borrow_return`.`apply_id` AS `applyId`,`common_jp_borrow_return`.`current_state` AS `currentState`,`common_jp_borrow_return`.`order_code` AS `order`,`common_jp_borrow_return`.`create_time` AS `createTime`,`common_jp_borrow_return`.`org_id` AS `Orgid`,'借用' AS `type`,'未完成' AS `State` from (`common_jp_borrow_return` join `common_jp_process_current` on((`common_jp_borrow_return`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and ((`common_jp_borrow_return`.`current_state` = 0) or (`common_jp_borrow_return`.`current_state` = 1)) and (`common_jp_borrow_return`.`action_type` = 0)) union select `common_jp_borrow_return`.`id` AS `Id`,`common_jp_borrow_return`.`apply_id` AS `applyId`,`common_jp_borrow_return`.`current_state` AS `currentState`,`common_jp_borrow_return`.`order_code` AS `order`,`common_jp_borrow_return`.`create_time` AS `createTime`,`common_jp_borrow_return`.`org_id` AS `Orgid`,'借用' AS `type`,'已完成' AS `State` from (`common_jp_borrow_return` join `common_jp_process_current` on((`common_jp_borrow_return`.`apply_id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and (`common_jp_borrow_return`.`current_state` = 2) and (`common_jp_borrow_return`.`action_type` = 0)) union select `common_jp_borrow_return`.`id` AS `Id`,`common_jp_borrow_return`.`apply_id` AS `applyId`,`common_jp_borrow_return`.`current_state` AS `currentState`,`common_jp_borrow_return`.`order_code` AS `order`,`common_jp_borrow_return`.`create_time` AS `createTime`,`common_jp_borrow_return`.`org_id` AS `Orgid`,'领用' AS `type`,'已完成' AS `State` from `common_jp_borrow_return` where ((`common_jp_borrow_return`.`current_state` = 1) and (`common_jp_borrow_return`.`action_type` = 1)) union select `common_jp_borrow_return`.`id` AS `Id`,`common_jp_borrow_return`.`apply_id` AS `applyId`,`common_jp_borrow_return`.`current_state` AS `currentState`,`common_jp_borrow_return`.`order_code` AS `order`,`common_jp_borrow_return`.`create_time` AS `createTime`,`common_jp_borrow_return`.`org_id` AS `Orgid`,'领用' AS `type`,'未完成' AS `State` from `common_jp_borrow_return` where ((`common_jp_borrow_return`.`current_state` = 0) and (`common_jp_borrow_return`.`action_type` = 1)) union select `common_jp_fix_useless`.`id` AS `Id`,`common_jp_fix_useless`.`estimate_id` AS `applyId`,`common_jp_fix_useless`.`current_state` AS `currentState`,`common_jp_fix_useless`.`order_code` AS `order`,`common_jp_fix_useless`.`create_time` AS `createTime`,`common_jp_fix_useless`.`org_id` AS `Orgid`,'维修' AS `type`,'未完成' AS `State` from `common_jp_fix_useless` where ((`common_jp_fix_useless`.`action` = 0) and ((`common_jp_fix_useless`.`current_state` = 0) or (`common_jp_fix_useless`.`current_state` = 1))) union select `common_jp_fix_useless`.`id` AS `Id`,`common_jp_fix_useless`.`estimate_id` AS `applyId`,`common_jp_fix_useless`.`current_state` AS `currentState`,`common_jp_fix_useless`.`order_code` AS `order`,`common_jp_fix_useless`.`create_time` AS `createTime`,`common_jp_fix_useless`.`org_id` AS `Orgid`,'维修' AS `type`,'已完成' AS `State` from `common_jp_fix_useless` where ((`common_jp_fix_useless`.`action` = 0) and (`common_jp_fix_useless`.`current_state` = 2)) union select `common_jp_fix_useless`.`id` AS `Id`,`common_jp_fix_useless`.`estimate_id` AS `applyId`,`common_jp_fix_useless`.`current_state` AS `currentState`,`common_jp_fix_useless`.`order_code` AS `order`,`common_jp_fix_useless`.`create_time` AS `createTime`,`common_jp_fix_useless`.`org_id` AS `Orgid`,'报废' AS `type`,'未完成' AS `State` from `common_jp_fix_useless` where ((`common_jp_fix_useless`.`action` = 1) and (`common_jp_fix_useless`.`current_state` = 0)) union select `common_jp_fix_useless`.`id` AS `Id`,`common_jp_fix_useless`.`estimate_id` AS `applyId`,`common_jp_fix_useless`.`current_state` AS `currentState`,`common_jp_fix_useless`.`order_code` AS `order`,`common_jp_fix_useless`.`create_time` AS `createTime`,`common_jp_fix_useless`.`org_id` AS `Orgid`,'维修' AS `type`,'已完成' AS `State` from `common_jp_fix_useless` where ((`common_jp_fix_useless`.`action` = 1) and (`common_jp_fix_useless`.`current_state` = 1)) union select `common_jp_purchase_order`.`id` AS `Id`,`common_jp_purchase_order`.`id` AS `applyId`,`common_jp_purchase_order`.`current_state` AS `currentState`,`common_jp_purchase_order`.`order_code` AS `order`,`common_jp_purchase_order`.`create_time` AS `createTime`,`common_jp_purchase_order`.`org_id` AS `Orgid`,'采购' AS `type`,'未完成' AS `State` from (`common_jp_purchase_order` join `common_jp_process_current` on((`common_jp_purchase_order`.`id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and (isnull(`common_jp_purchase_order`.`current_state`) or (`common_jp_purchase_order`.`current_state` = 0))) union select `common_jp_purchase_order`.`id` AS `Id`,`common_jp_purchase_order`.`id` AS `applyId`,`common_jp_purchase_order`.`current_state` AS `currentState`,`common_jp_purchase_order`.`order_code` AS `order`,`common_jp_purchase_order`.`create_time` AS `createTime`,`common_jp_purchase_order`.`org_id` AS `Orgid`,'采购' AS `type`,'已完成' AS `State` from (`common_jp_purchase_order` join `common_jp_process_current` on((`common_jp_purchase_order`.`id` = `common_jp_process_current`.`order_id`))) where ((`common_jp_process_current`.`flow_state` = 'true') and (`common_jp_purchase_order`.`current_state` = 1));

-- ----------------------------
-- View structure for view_outin_order
-- ----------------------------
DROP VIEW IF EXISTS `view_outin_order`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_outin_order` AS select `junmppolicesql`.`common_jp_transfer`.`id` AS `Id`,`junmppolicesql`.`common_jp_transfer`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_transfer`.`order` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_transfer`.`create_time` AS `createTime`,4 AS `type` from ((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_transfer` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_transfer`.`receive_warehouse_id`))) join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_transfer`.`apply_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`junmppolicesql`.`common_jp_transfer`.`action_type` = 0) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `junmppolicesql`.`common_jp_purchase_order`.`id` AS `Id`,`junmppolicesql`.`common_jp_purchase_order`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_purchase_order`.`order_code` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_purchase_order`.`create_time` AS `createTime`,1 AS `type` from ((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_purchase_order` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_purchase_order`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_purchase_order`.`id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true') union select `junmppolicesql`.`common_jp_fix_useless`.`id` AS `Id`,`junmppolicesql`.`common_jp_fix_useless`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_fix_useless`.`order_code` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_fix_useless`.`create_time` AS `createTime`,5 AS `type` from ((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_fix_useless` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_fix_useless`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_fix_useless`.`estimate_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`junmppolicesql`.`common_jp_fix_useless`.`action` = 0) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `junmppolicesql`.`common_jp_fix_useless`.`id` AS `Id`,`junmppolicesql`.`common_jp_fix_useless`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_fix_useless`.`order_code` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_fix_useless`.`create_time` AS `createTime`,6 AS `type` from ((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_fix_useless` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_fix_useless`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_fix_useless`.`estimate_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`junmppolicesql`.`common_jp_fix_useless`.`action` = 1) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `junmppolicesql`.`common_jp_borrow_return`.`id` AS `Id`,`junmppolicesql`.`common_jp_borrow_return`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_borrow_return`.`order_code` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_borrow_return`.`create_time` AS `createTime`,3 AS `type` from ((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_borrow_return` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_borrow_return`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_borrow_return`.`apply_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where (`junmppolicesql`.`common_jp_borrow_return`.`action_type` = 1) union select `junmppolicesql`.`common_jp_borrow_return`.`id` AS `Id`,`junmppolicesql`.`common_jp_borrow_return`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_borrow_return`.`order_code` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_borrow_return`.`create_time` AS `createTime`,2 AS `type` from (((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_borrow_return` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_borrow_return`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_borrow_return`.`apply_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) join (select `t`.`id` AS `id`,`t`.`Counts` AS `Counts`,`t`.`RealCount` AS `RealCount` from (select `t0`.`id` AS `id`,(select count(0) from `junmppolicesql`.`common_jp_borrow_return_detail_reality` `t1` where (`t1`.`reality_id` = `t0`.`id`)) AS `Counts`,(select count(0) from `junmppolicesql`.`common_jp_borrow_return_detail_reality` `t1` where ((`t1`.`reality_id` = `t0`.`id`) and (`t1`.`inside_real_count` = 0) and (`t1`.`state` = 1))) AS `RealCount` from `junmppolicesql`.`common_jp_borrow_return` `t0` group by `t0`.`id`) `t` where (`t`.`RealCount` <> `t`.`Counts`)) `t` on((`t`.`id` = `junmppolicesql`.`common_jp_borrow_return`.`id`))) where ((`junmppolicesql`.`common_jp_borrow_return`.`action_type` = 0) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `junmppolicesql`.`common_jp_borrow_return`.`id` AS `Id`,`junmppolicesql`.`common_jp_borrow_return`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_borrow_return`.`order_code` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_borrow_return`.`create_time` AS `createTime`,11 AS `type` from (((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_borrow_return` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_borrow_return`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_borrow_return`.`apply_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) join (select `t`.`id` AS `id`,`t`.`Counts` AS `Counts`,`t`.`RealCount` AS `RealCount` from (select `t0`.`id` AS `id`,(select count(0) from `junmppolicesql`.`common_jp_borrow_return_detail_reality` `t1` where (`t1`.`reality_id` = `t0`.`id`)) AS `Counts`,(select count(0) from `junmppolicesql`.`common_jp_borrow_return_detail_reality` `t1` where ((`t1`.`reality_id` = `t0`.`id`) and (`t1`.`inside_real_count` = 0) and (`t1`.`state` = 1))) AS `RealCount` from `junmppolicesql`.`common_jp_borrow_return` `t0` group by `t0`.`id`) `t` where (`t`.`RealCount` = `t`.`Counts`)) `t` on((`t`.`id` = `junmppolicesql`.`common_jp_borrow_return`.`id`))) where ((`junmppolicesql`.`common_jp_borrow_return`.`action_type` = 0) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `t1`.`Id` AS `Id`,`t1`.`currentState` AS `currentState`,`t1`.`order` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`t1`.`warehouse_id` AS `warehouseId`,`t1`.`createTime` AS `createTime`,0 AS `type` from ((((select `junmppolicesql`.`common_jp_transfer`.`id` AS `Id`,`junmppolicesql`.`common_jp_transfer`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_transfer`.`order` AS `order`,`junmppolicesql`.`common_jp_transfer_detail_reality`.`warehouse_id` AS `warehouse_id`,`junmppolicesql`.`common_jp_transfer`.`action_type` AS `action_type`,`junmppolicesql`.`common_jp_transfer`.`create_time` AS `createTime`,`junmppolicesql`.`common_jp_transfer`.`apply_id` AS `applyId` from (`junmppolicesql`.`common_jp_transfer` join `junmppolicesql`.`common_jp_transfer_detail_reality` on((`junmppolicesql`.`common_jp_transfer`.`id` = `junmppolicesql`.`common_jp_transfer_detail_reality`.`reality_id`))))) `t1` join `junmppolicesql`.`base_jp_warehouse` on((`t1`.`warehouse_id` = `junmppolicesql`.`base_jp_warehouse`.`id`))) left join `junmppolicesql`.`common_jp_process_current` on((`t1`.`applyId` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`t1`.`action_type` = 0) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `junmppolicesql`.`common_jp_transfer`.`id` AS `Id`,`junmppolicesql`.`common_jp_transfer`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_transfer`.`order` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_transfer`.`create_time` AS `createTime`,8 AS `type` from ((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_transfer` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_transfer`.`receive_warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_transfer`.`apply_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`junmppolicesql`.`common_jp_transfer`.`action_type` = 1) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `junmppolicesql`.`common_jp_transfer`.`id` AS `Id`,`junmppolicesql`.`common_jp_transfer`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_transfer`.`order` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`junmppolicesql`.`base_jp_warehouse`.`id` AS `warehouseId`,`junmppolicesql`.`common_jp_transfer`.`create_time` AS `createTime`,10 AS `type` from ((`junmppolicesql`.`base_jp_warehouse` join `junmppolicesql`.`common_jp_transfer` on((`junmppolicesql`.`base_jp_warehouse`.`id` = `junmppolicesql`.`common_jp_transfer`.`receive_warehouse_id`))) left join `junmppolicesql`.`common_jp_process_current` on((`junmppolicesql`.`common_jp_transfer`.`apply_id` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`junmppolicesql`.`common_jp_transfer`.`action_type` = 2) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `t1`.`Id` AS `Id`,`t1`.`currentState` AS `currentState`,`t1`.`order` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`t1`.`warehouse_id` AS `warehouseId`,`t1`.`createTime` AS `createTime`,7 AS `type` from ((((select `junmppolicesql`.`common_jp_transfer`.`id` AS `Id`,`junmppolicesql`.`common_jp_transfer`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_transfer`.`order` AS `order`,`junmppolicesql`.`common_jp_transfer_detail_reality`.`warehouse_id` AS `warehouse_id`,`junmppolicesql`.`common_jp_transfer`.`create_time` AS `createTime`,`junmppolicesql`.`common_jp_transfer`.`action_type` AS `action_type`,`junmppolicesql`.`common_jp_transfer`.`apply_id` AS `applyId` from (`junmppolicesql`.`common_jp_transfer` join `junmppolicesql`.`common_jp_transfer_detail_reality` on((`junmppolicesql`.`common_jp_transfer`.`id` = `junmppolicesql`.`common_jp_transfer_detail_reality`.`reality_id`))))) `t1` join `junmppolicesql`.`base_jp_warehouse` on((`t1`.`warehouse_id` = `junmppolicesql`.`base_jp_warehouse`.`id`))) left join `junmppolicesql`.`common_jp_process_current` on((`t1`.`applyId` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`t1`.`action_type` = 1) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `t1`.`Id` AS `Id`,`t1`.`currentState` AS `currentState`,`t1`.`order` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`t1`.`warehouse_id` AS `warehouseId`,`t1`.`createTime` AS `createTime`,9 AS `type` from ((((select `junmppolicesql`.`common_jp_transfer`.`id` AS `Id`,`junmppolicesql`.`common_jp_transfer`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_transfer`.`order` AS `order`,`junmppolicesql`.`common_jp_transfer_detail_reality`.`warehouse_id` AS `warehouse_id`,`junmppolicesql`.`common_jp_transfer`.`create_time` AS `createTime`,`junmppolicesql`.`common_jp_transfer`.`action_type` AS `action_type`,`junmppolicesql`.`common_jp_transfer`.`apply_id` AS `applyId` from (`junmppolicesql`.`common_jp_transfer` join `junmppolicesql`.`common_jp_transfer_detail_reality` on((`junmppolicesql`.`common_jp_transfer`.`id` = `junmppolicesql`.`common_jp_transfer_detail_reality`.`reality_id`))))) `t1` join `junmppolicesql`.`base_jp_warehouse` on((`t1`.`warehouse_id` = `junmppolicesql`.`base_jp_warehouse`.`id`))) left join `junmppolicesql`.`common_jp_process_current` on((`t1`.`applyId` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`t1`.`action_type` = 2) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true')) union select `t1`.`Id` AS `Id`,`t1`.`currentState` AS `currentState`,`t1`.`order` AS `order`,`junmppolicesql`.`base_jp_warehouse`.`name` AS `warehouseName`,`t1`.`warehouse_id` AS `warehouseId`,`t1`.`createTime` AS `createTime`,10 AS `type` from ((((select `junmppolicesql`.`common_jp_transfer`.`id` AS `Id`,`junmppolicesql`.`common_jp_transfer`.`current_state` AS `currentState`,`junmppolicesql`.`common_jp_transfer`.`order` AS `order`,`junmppolicesql`.`common_jp_transfer_detail_reality`.`received_warehouse_id` AS `warehouse_id`,`junmppolicesql`.`common_jp_transfer`.`create_time` AS `createTime`,`junmppolicesql`.`common_jp_transfer`.`action_type` AS `action_type`,`junmppolicesql`.`common_jp_transfer`.`apply_id` AS `applyId` from (`junmppolicesql`.`common_jp_transfer` join `junmppolicesql`.`common_jp_transfer_detail_reality` on((`junmppolicesql`.`common_jp_transfer`.`id` = `junmppolicesql`.`common_jp_transfer_detail_reality`.`reality_id`))))) `t1` join `junmppolicesql`.`base_jp_warehouse` on((`t1`.`warehouse_id` = `junmppolicesql`.`base_jp_warehouse`.`id`))) left join `junmppolicesql`.`common_jp_process_current` on((`t1`.`applyId` = `junmppolicesql`.`common_jp_process_current`.`order_id`))) where ((`t1`.`action_type` = 2) and (`junmppolicesql`.`common_jp_process_current`.`flow_state` = 'true'));

-- ----------------------------
-- View structure for view_state
-- ----------------------------
DROP VIEW IF EXISTS `view_state`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_state` AS select `eqstate`.`out_in_state` AS `out_in_state`,`eqstate`.`createTime` AS `createTime`,`eqstate`.`eqiupment_id` AS `eqiupment_id`,`invs`.`detailCode` AS `detailCode`,`invs`.`detailName` AS `detailName`,`invs`.`sizeName` AS `sizeName`,`orginfo`.`orgName` AS `orgName`,`orginfo`.`orgId` AS `orgId` from ((`junmppolicesql`.`common_jp_equipment_state` `eqstate` left join (select `inv`.`id` AS `invId`,`detail`.`equipment_id` AS `detailCode`,`inv`.`epc` AS `epc`,`detail`.`name` AS `detailName`,`size`.`size_name` AS `sizeName` from ((`junmppolicesql`.`common_jp_equipment_inventory` `inv` join `junmppolicesql`.`base_jp_equipment_detail` `detail` on((`inv`.`equipment_code` = `detail`.`id`))) join `junmppolicesql`.`base_jp_equipment_size` `size` on((`inv`.`equipment_sizecode` = `size`.`id`)))) `invs` on((`eqstate`.`eqiupment_id` = `invs`.`invId`))) left join (select `org`.`id` AS `orgId`,`org`.`name` AS `orgName`,`warehouse`.`id` AS `warehouseId` from (`junmppolicesql`.`base_jp_warehouse` `warehouse` join `junmppolicesql`.`base_jp_organization` `org` on((`warehouse`.`orgization_id` = `org`.`id`)))) `orginfo` on((`orginfo`.`warehouseId` = `eqstate`.`warehouse_id`))) where ((trim(`eqstate`.`eqiupment_id`) <> '') and (trim(`orginfo`.`orgName`) <> ''));

-- ----------------------------
-- View structure for view_sy_p
-- ----------------------------
DROP VIEW IF EXISTS `view_sy_p`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_sy_p` AS select `tablesum`.`org_id` AS `org_id`,`tablesum`.`org_name` AS `org_name`,`tablesum`.`area_name` AS `area_name`,`tablesum`.`warehouse_name` AS `warehouse_name`,`tablesum`.`warehouse_code` AS `warehouse_code`,`tablesum`.`size_id` AS `size_id`,`tablesum`.`equ_name` AS `equ_name`,`tablesum`.`size_code` AS `size_code`,`tablesum`.`size_name` AS `size_name`,`tablesum`.`sizeCount` AS `sizeCount`,cast(round(((cast(coalesce(`table7`.`weekCount`,0) as decimal(20,2)) / (cast(coalesce(nullif(`tablesum`.`sizeCount`,0),1) as decimal(20,2)) * 7)) * 100),2) as decimal(10,0)) AS `weekP`,cast(round(((cast(coalesce(`table30`.`monthCount`,0) as decimal(20,2)) / (cast(coalesce(nullif(`tablesum`.`sizeCount`,0),1) as decimal(20,2)) * 30)) * 100),2) as decimal(10,0)) AS `monthP` from ((((select `a`.`org_id` AS `org_id`,`a`.`org_name` AS `org_name`,`a`.`area_name` AS `area_name`,`a`.`warehouse_name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`size_id` AS `size_id`,`a`.`equ_name` AS `equ_name`,`a`.`size_code` AS `size_code`,`a`.`size_name` AS `size_name`,sum((case when ((`a`.`current_state` = 5) or (`a`.`current_state` = 6)) then 0 else 1 end)) AS `sizeCount` from (select `d`.`id` AS `org_id`,`d`.`name` AS `org_name`,`d`.`area_name` AS `area_name`,`c`.`name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`current_state` AS `current_state`,`b`.`size_id` AS `size_id`,`b`.`equ_name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (((`junmppolicesql`.`common_jp_equipment_inventory` `a` left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `b` on((`a`.`equipment_sizecode` = `b`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `c` on((`a`.`warehouse_code` = `c`.`id`))) left join `junmppolicesql`.`base_jp_organization` `d` on((`c`.`orgization_id` = `d`.`id`)))) `a` group by `a`.`org_id`,`a`.`org_name`,`a`.`area_name`,`a`.`warehouse_name`,`a`.`warehouse_code`,`a`.`size_id`,`a`.`equ_name`,`a`.`size_code`,`a`.`size_name`)) `tablesum` left join (select `e`.`id` AS `org_id`,`e`.`name` AS `org_name`,`e`.`area_name` AS `area_name`,`d`.`name` AS `warehouse_name`,`b`.`warehouse_code` AS `warehouse_code`,`c`.`size_id` AS `size_id`,`c`.`equ_name` AS `equ_name`,`c`.`size_code` AS `size_code`,`c`.`size_name` AS `size_name`,count(distinct (`a`.`eqiupment_id` + cast(cast(`a`.`outTime` as date) as char charset utf8mb4))) AS `weekCount` from ((((`junmppolicesql`.`common_jp_equipment_state` `a` left join `junmppolicesql`.`common_jp_equipment_inventory` `b` on((`a`.`eqiupment_id` = `b`.`id`))) left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `c` on((`b`.`equipment_sizecode` = `c`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `d` on((`b`.`warehouse_code` = `d`.`id`))) left join `junmppolicesql`.`base_jp_organization` `e` on((`d`.`orgization_id` = `e`.`id`))) where ((timestampdiff(DAY,`a`.`outTime`,now()) <= 7) and (`a`.`state` in (1,3)) and (`a`.`action_state` in (2,3,5,14,15))) group by `e`.`id`,`e`.`name`,`e`.`area_name`,`d`.`name`,`b`.`warehouse_code`,`c`.`size_id`,`c`.`equ_name`,`c`.`size_code`,`c`.`size_name`) `table7` on(((`tablesum`.`org_id` = `table7`.`org_id`) and (`tablesum`.`warehouse_code` = `table7`.`warehouse_code`) and (`tablesum`.`size_id` = `table7`.`size_id`)))) left join (select `e`.`id` AS `org_id`,`e`.`name` AS `org_name`,`e`.`area_name` AS `area_name`,`d`.`name` AS `warehouse_name`,`b`.`warehouse_code` AS `warehouse_code`,`c`.`size_id` AS `size_id`,`c`.`equ_name` AS `equ_name`,`c`.`size_code` AS `size_code`,`c`.`size_name` AS `size_name`,count(distinct (`a`.`eqiupment_id` + cast(cast(`a`.`outTime` as date) as char charset utf8mb4))) AS `monthCount` from ((((`junmppolicesql`.`common_jp_equipment_state` `a` left join `junmppolicesql`.`common_jp_equipment_inventory` `b` on((`a`.`eqiupment_id` = `b`.`id`))) left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `c` on((`b`.`equipment_sizecode` = `c`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `d` on((`b`.`warehouse_code` = `d`.`id`))) left join `junmppolicesql`.`base_jp_organization` `e` on((`d`.`orgization_id` = `e`.`id`))) where ((timestampdiff(DAY,`a`.`outTime`,now()) <= 30) and (`a`.`state` in (1,3)) and (`a`.`action_state` in (2,3,5,14,15))) group by `e`.`id`,`e`.`name`,`e`.`area_name`,`d`.`name`,`b`.`warehouse_code`,`c`.`size_id`,`c`.`equ_name`,`c`.`size_code`,`c`.`size_name`) `table30` on(((`tablesum`.`org_id` = `table30`.`org_id`) and (`tablesum`.`warehouse_code` = `table30`.`warehouse_code`) and (`tablesum`.`size_id` = `table30`.`size_id`))));

-- ----------------------------
-- View structure for view_useless
-- ----------------------------
DROP VIEW IF EXISTS `view_useless`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_useless` AS select `a`.`id` AS `org_id`,`a`.`name` AS `org_name`,`a`.`code` AS `org_code`,`a`.`find_code` AS `find_code`,`a`.`area_name` AS `area_name`,`b`.`action` AS `action`,`b`.`fix_time` AS `fix_time`,`c`.`quantity` AS `quantity`,`c`.`state` AS `state`,`e`.`NAME` AS `equipment_name`,`e`.`parent_name` AS `parent_name`,`f`.`name` AS `warehouse_name`,`f`.`id` AS `warehouse_code` from (((((`junmppolicesql`.`base_jp_organization` `a` left join `junmppolicesql`.`base_jp_warehouse` `f` on((`a`.`id` = `f`.`orgization_id`))) left join `junmppolicesql`.`common_jp_fix_useless` `b` on((`f`.`id` = `b`.`warehouse_id`))) left join `junmppolicesql`.`common_jp_fix_useless_detail` `c` on((`c`.`order_id` = `b`.`id`))) left join `junmppolicesql`.`base_jp_equipment_detail` `d` on((`c`.`equipment_id` = `d`.`id`))) left join (select `a`.`id` AS `id`,`a`.`name` AS `NAME`,`c`.`name` AS `parent_name` from ((`junmppolicesql`.`base_jp_equipment_info` `a` join `junmppolicesql`.`base_jp_equipment_info` `b` on((`b`.`id` = `a`.`parent_id`))) join `junmppolicesql`.`base_jp_equipment_info` `c` on((`c`.`id` = `b`.`parent_id`)))) `e` on((`d`.`equipment_id` = `e`.`id`))) where (`a`.`state` = '1');

-- ----------------------------
-- View structure for view_wx_p
-- ----------------------------
DROP VIEW IF EXISTS `view_wx_p`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `view_wx_p` AS select `tablesum`.`org_id` AS `org_id`,`tablesum`.`org_name` AS `org_name`,`tablesum`.`area_name` AS `area_name`,`tablesum`.`warehouse_name` AS `warehouse_name`,`tablesum`.`warehouse_code` AS `warehouse_code`,`tablesum`.`size_id` AS `size_id`,`tablesum`.`equ_name` AS `equ_name`,`tablesum`.`size_code` AS `size_code`,`tablesum`.`size_name` AS `size_name`,`tablesum`.`sizeCount` AS `sizeCount`,cast(round(((cast(coalesce(`table7`.`weekCount`,0) as decimal(20,2)) / cast(coalesce(nullif(`tablesum`.`sizeCount`,0),1) as decimal(20,2))) * 100),2) as decimal(10,0)) AS `weekP`,cast(round(((cast(coalesce(`table30`.`monthCount`,0) as decimal(20,2)) / cast(coalesce(nullif(`tablesum`.`sizeCount`,0),1) as decimal(20,2))) * 100),2) as decimal(10,0)) AS `monthP` from ((((select `a`.`org_id` AS `org_id`,`a`.`org_name` AS `org_name`,`a`.`area_name` AS `area_name`,`a`.`warehouse_name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`size_id` AS `size_id`,`a`.`equ_name` AS `equ_name`,`a`.`size_code` AS `size_code`,`a`.`size_name` AS `size_name`,count(`a`.`current_state`) AS `sizeCount` from (select `d`.`id` AS `org_id`,`d`.`name` AS `org_name`,`d`.`area_name` AS `area_name`,`c`.`name` AS `warehouse_name`,`a`.`warehouse_code` AS `warehouse_code`,`a`.`current_state` AS `current_state`,`b`.`size_id` AS `size_id`,`b`.`equ_name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (((`junmppolicesql`.`common_jp_equipment_inventory` `a` left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `b` on((`a`.`equipment_sizecode` = `b`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `c` on((`a`.`warehouse_code` = `c`.`id`))) left join `junmppolicesql`.`base_jp_organization` `d` on((`c`.`orgization_id` = `d`.`id`)))) `a` group by `a`.`org_id`,`a`.`org_name`,`a`.`area_name`,`a`.`warehouse_name`,`a`.`warehouse_code`,`a`.`size_id`,`a`.`equ_name`,`a`.`size_code`,`a`.`size_name`)) `tablesum` left join (select `e`.`id` AS `org_id`,`e`.`name` AS `org_name`,`e`.`area_name` AS `area_name`,`d`.`name` AS `warehouse_name`,`a`.`warehouse_id` AS `warehouse_code`,`c`.`size_id` AS `size_id`,`c`.`equ_name` AS `equ_name`,`c`.`size_code` AS `size_code`,`c`.`size_name` AS `size_name`,count(`e`.`id`) AS `weekCount` from ((((`junmppolicesql`.`common_jp_fix_useless` `a` left join `junmppolicesql`.`common_jp_fix_useless_detail` `b` on((`b`.`order_id` = `a`.`id`))) left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `c` on((`b`.`size_id` = `c`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `d` on((`a`.`warehouse_id` = `d`.`id`))) left join `junmppolicesql`.`base_jp_organization` `e` on((`d`.`orgization_id` = `e`.`id`))) where ((timestampdiff(DAY,`a`.`fix_time`,now()) <= 7) and (`a`.`action` = 0)) group by `e`.`id`,`e`.`name`,`e`.`area_name`,`d`.`name`,`a`.`warehouse_id`,`c`.`size_id`,`c`.`equ_name`,`c`.`size_code`,`c`.`size_name`) `table7` on(((`tablesum`.`org_id` = `table7`.`org_id`) and (`tablesum`.`warehouse_code` = `table7`.`warehouse_code`) and (`tablesum`.`size_id` = `table7`.`size_id`)))) left join (select `e`.`id` AS `org_id`,`e`.`name` AS `org_name`,`e`.`area_name` AS `area_name`,`d`.`name` AS `warehouse_name`,`a`.`warehouse_id` AS `warehouse_code`,`c`.`size_id` AS `size_id`,`c`.`equ_name` AS `equ_name`,`c`.`size_code` AS `size_code`,`c`.`size_name` AS `size_name`,count(`e`.`id`) AS `monthCount` from ((((`junmppolicesql`.`common_jp_fix_useless` `a` left join `junmppolicesql`.`common_jp_fix_useless_detail` `b` on((`b`.`order_id` = `a`.`id`))) left join (select `b`.`id` AS `size_id`,`a`.`name` AS `equ_name`,`b`.`size_code` AS `size_code`,`b`.`size_name` AS `size_name` from (`junmppolicesql`.`base_jp_equipment_detail` `a` left join `junmppolicesql`.`base_jp_equipment_size` `b` on((`a`.`id` = `b`.`detail_id`)))) `c` on((`b`.`size_id` = `c`.`size_id`))) left join `junmppolicesql`.`base_jp_warehouse` `d` on((`a`.`warehouse_id` = `d`.`id`))) left join `junmppolicesql`.`base_jp_organization` `e` on((`d`.`orgization_id` = `e`.`id`))) where ((timestampdiff(DAY,`a`.`fix_time`,now()) <= 30) and (`a`.`action` = 0)) group by `e`.`id`,`e`.`name`,`e`.`area_name`,`d`.`name`,`a`.`warehouse_id`,`c`.`size_id`,`c`.`equ_name`,`c`.`size_code`,`c`.`size_name`) `table30` on(((`tablesum`.`org_id` = `table30`.`org_id`) and (`tablesum`.`warehouse_code` = `table30`.`warehouse_code`) and (`tablesum`.`size_id` = `table30`.`size_id`))));

-- ----------------------------
-- View structure for v_borrow_view
-- ----------------------------
DROP VIEW IF EXISTS `v_borrow_view`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `v_borrow_view` AS select (case when (`t0`.`expectedReturnTime` > now()) then 'false' else 'true' end) AS `is_overdue`,`t0`.`id` AS `id`,`t2`.`name` AS `warehouse_name`,`t0`.`org_id` AS `org_id`,`t0`.`apply_user_name` AS `apply_user_name`,`t0`.`apply_time` AS `apply_time`,`t0`.`expectedReturnTime` AS `expectedTime`,'本库借用' AS `borrow_type`,`t5`.`current_state` AS `current_state`,`t0`.`action_type` AS `action_type` from ((((`common_jp_borrow_return_apply` `t0` join `common_jp_borrow_return_detail_reality` `t4` on((`t4`.`estimate_id` = `t0`.`id`))) join `common_jp_borrow_return` `t5` on((`t0`.`id` = `t5`.`apply_id`))) left join `common_jp_process_current` `t1` on((`t0`.`process_current_id` = `t1`.`id`))) left join `base_jp_warehouse` `t2` on((`t0`.`warehouse_id` = `t2`.`id`))) where ((`t0`.`action_type` = 0) and (`t1`.`flow_state` = 'true') and (`t4`.`real_count` > 0) and (`t5`.`current_state` = 1)) union select (case when (`t0`.`expectedReturnTime` > now()) then 'false' else 'true' end) AS `is_overdue`,`t0`.`id` AS `id`,`t2`.`name` AS `warehouse_name`,`t0`.`transfer_id` AS `org_id`,`t0`.`apply_user_name` AS `apply_user_name`,`t0`.`apply_time` AS `apply_time`,`t0`.`expectedReturnTime` AS `expectedTime`,'跨库借用' AS `borrow_type`,`t5`.`current_state` AS `current_state`,`t0`.`action_type` AS `action_type` from ((((`common_jp_transfer_apply` `t0` left join `common_jp_transfer` `t5` on((`t5`.`apply_id` = `t0`.`id`))) join `common_jp_transfer_detail_reality` `t4` on((`t4`.`estimate_id` = `t0`.`id`))) left join `common_jp_process_current` `t1` on((`t0`.`process_current_id` = `t1`.`id`))) left join `base_jp_warehouse` `t2` on((`t0`.`transfer_warehouse` = `t2`.`id`))) where ((not(`t0`.`order` in (select `common_jp_transfer_apply`.`order` from `common_jp_transfer_apply` where (`common_jp_transfer_apply`.`action_type` = 2)))) and (((`t0`.`action_type` = 1) and (`t5`.`current_state` <> 3)) or ((`t0`.`action_type` = 2) and (`t5`.`current_state` <> 2))) and (`t1`.`flow_state` = 'true') and (`t4`.`real_count` > 0));

-- ----------------------------
-- View structure for v_order_info
-- ----------------------------
DROP VIEW IF EXISTS `v_order_info`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `v_order_info` AS select `t0`.`id` AS `id`,`t0`.`apply_id` AS `apply_id`,`t0`.`warehouse_id` AS `warehouse_id`,`t0`.`order_code` AS `order_code`,`t0`.`org_id` AS `org_id`,`t0`.`create_time` AS `create_time`,`t0`.`is_work` AS `is_work`,`common_jp_borrow_return_apply`.`police_note` AS `borrow_police`,'' AS `receive_warehouse_id`,(case when (`t0`.`action_type` = 0) then '借用' when (`t0`.`action_type` = 1) then '领用' end) AS `order_type`,(select group_concat(`c2`.`name` separator ',') from (`common_jp_borrow_return_detail_reality` `c1` left join `base_jp_equipment_detail` `c2` on((`c1`.`equipment_detail_id` = `c2`.`id`))) where (`c1`.`reality_id` = `t0`.`id`)) AS `equNames` from ((`common_jp_borrow_return` `t0` left join `common_jp_borrow_return_apply` on((`t0`.`apply_id` = `common_jp_borrow_return_apply`.`id`))) left join `common_jp_process_current` on((`common_jp_borrow_return_apply`.`id` = `common_jp_process_current`.`order_id`))) where ((((`t0`.`action_type` = 0) and (`common_jp_process_current`.`id` is not null)) or (`t0`.`action_type` = 1)) and (`t0`.`current_state` = 0)) union select `t0`.`id` AS `id`,`t0`.`apply_id` AS `apply_id`,`t1`.`warehouse_id` AS `warehouse_id`,`t0`.`order` AS `order_code`,`t2`.`orgization_id` AS `org_id`,`t0`.`create_time` AS `create_time`,`t1`.`is_work` AS `is_work`,'' AS `borrow_police`,`t0`.`receive_warehouse_id` AS `receive_warehouse_id`,(case when (`t0`.`action_type` = 1) then '跨库借用' when (`t0`.`action_type` = 0) then '库存调拨' when (`t0`.`action_type` = 2) then '跨库归还' end) AS `order_type`,(select group_concat(`c2`.`name` separator ',') from (`common_jp_transfer_detail_reality` `c1` left join `base_jp_equipment_detail` `c2` on((`c1`.`equipment_detail_id` = `c2`.`id`))) where ((`c1`.`warehouse_id` = `t1`.`warehouse_id`) and (`c1`.`reality_id` = `t0`.`id`))) AS `equNames` from ((`common_jp_transfer` `t0` join `common_jp_transfer_detail_reality` `t1` on((`t1`.`reality_id` = `t0`.`id`))) left join `base_jp_warehouse` `t2` on((`t2`.`id` = `t1`.`warehouse_id`))) where (`t0`.`current_state` = 0) group by (case when (`t0`.`action_type` = 1) then '跨库借用' when (`t0`.`action_type` = 0) then '库存调拨' when (`t0`.`action_type` = 2) then '跨库归还' end),`t0`.`id`,`t0`.`apply_id`,`t1`.`warehouse_id`,`t0`.`order`,`t2`.`orgization_id`,`t0`.`create_time`,`t1`.`is_work`;

-- ----------------------------
-- View structure for v_scrap_view
-- ----------------------------
DROP VIEW IF EXISTS `v_scrap_view`;
CREATE ALGORITHM = UNDEFINED SQL SECURITY DEFINER VIEW `v_scrap_view` AS select `t0`.`id` AS `id`,`t0`.`epc` AS `epc`,`t2`.`id` AS `sizeId`,`t2`.`size_name` AS `sizeName`,`t4`.`id` AS `supplierId`,`t4`.`name` AS `supplierName`,`t3`.`name` AS `equName`,`t3`.`id` AS `equId`,`t1`.`name` AS `warehouseName`,`t1`.`orgization_id` AS `orgId`,`t1`.`id` AS `warehouseId`,`t0`.`current_state` AS `current_state`,`t0`.`shelfId` AS `shelfId`,`t5`.`code` AS `shelf_code`,`t5`.`name` AS `shelf_name`,`t0`.`shelf_range` AS `shelf_range`,`t0`.`shelf_row` AS `shelf_row`,`t0`.`shelf_column` AS `shelf_column`,(`t0`.`productTime` + interval `t0`.`warrantyCycle` month) AS `warrantyTime`,(case when ((`t0`.`productTime` + interval `t0`.`warrantyCycle` month) >= now()) then 'false' when ((`t0`.`productTime` + interval `t0`.`warrantyCycle` month) < now()) then 'true' when isnull((`t0`.`productTime` + interval `t0`.`warrantyCycle` month)) then 'false' end) AS `is_scrap` from (((((`common_jp_equipment_inventory` `t0` left join `base_jp_warehouse` `t1` on((`t0`.`warehouse_code` = `t1`.`id`))) left join `base_jp_equipment_size` `t2` on((`t0`.`equipment_sizecode` = `t2`.`id`))) left join `base_jp_equipment_detail` `t3` on((`t0`.`equipment_code` = `t3`.`id`))) left join `base_jp_supplier` `t4` on((`t0`.`supplier_code` = `t4`.`id`))) left join `base_jp_shelf_info` `t5` on((`t0`.`shelfId` = `t5`.`id`))) where ((`t0`.`current_state` <> 6) and (`t0`.`warrantyCycle` <> 0) and ((`t0`.`inventory_state` <> 'loss') or isnull(`t0`.`inventory_state`)));

-- ----------------------------
-- Function structure for Func_GetPY
-- ----------------------------
DROP FUNCTION IF EXISTS `Func_GetPY`;
delimiter ;;
CREATE FUNCTION `Func_GetPY`(name varchar(500), is_short bit)
 RETURNS varchar(1000) CHARSET utf8mb4
  COMMENT '中文直接转全拼或简拼，不支持多音字'
BEGIN
    /*
    参数说明：
        name：需要转换的字符串
        is_short：是否转换为简拼，0全拼/1简拼
    */
 
    DECLARE restr VARCHAR(1000) DEFAULT '';
    DECLARE codestr VARCHAR(50) DEFAULT '';
 
    WHILE length(name) > 0 DO
        /*从字符串中取出一个字符*/
        set codestr = left(name, 1);
        set name = SUBSTRING(name, 2);
 
        if not codestr REGEXP "[u0391-uFFE5]" then -- 是中文
            -- 得到这个字符的拼音
            SELECT a.CODE into codestr FROM sys_convert_fullpinyin a WHERE a.NAME=codestr limit 1;
        end if;
 
        -- 如果是多音字，取第一个拼音
		if LOCATE(',',codestr)  > 0 then
			set codestr = substring(codestr,1,LOCATE(',',codestr) - 1);
		end if;
 
        if is_short = 1 then
            set restr = concat(restr, left(codestr, 1));
        else
            set restr = concat(restr, codestr);
        end if;
 
    END WHILE;
 
    return restr;
END
;;
delimiter ;

-- ----------------------------
-- Event structure for c_update_safe_level
-- ----------------------------
DROP EVENT IF EXISTS `c_update_safe_level`;
delimiter ;;
CREATE EVENT `c_update_safe_level`
ON SCHEDULE
EVERY '1' DAY STARTS '2022-06-28 00:10:00'
DO BEGIN
	-- 即将报废
	UPDATE common_jp_equipment_inventory 
	SET safe_level = 1 
	WHERE 
	warrantyCycle!=0
	AND date_add(productTime, interval (warrantyCycle-1) MONTH) <=now();
	
	-- 已超期待报废
	UPDATE common_jp_equipment_inventory 
	SET safe_level = 2 
	WHERE 
	warrantyCycle!=0
	AND date_add(productTime, interval (warrantyCycle) MONTH) <=now();
END
;;
delimiter ;

SET FOREIGN_KEY_CHECKS = 1;
